/*
 * BiwaScheme 0.6.3 - R6RS Scheme in JavaScript
 *
 * Copyright (c) 2007-2014 Yutaka HARA (http://www.biwascheme.org/)
 * @license Licensed under the MIT license.
 */
var BiwaScheme=BiwaScheme||{};BiwaScheme.Version="0.6.3";BiwaScheme.GitCommit="379efea2002e0608ad8ed784015413d598cb97e7";function puts(str,no_newline){Console.puts(str,no_newline)}function p(){Console.p.apply(this,arguments)}BiwaScheme.TopEnv={};BiwaScheme.CoreEnv={};BiwaScheme.nil={toString:function(){return"nil"},to_write:function(){return"()"},to_array:function(){return[]},length:function(){return 0}};BiwaScheme.undef=new Object;BiwaScheme.undef.toString=function(){return"#<undef>"};BiwaScheme.debug=function(){var args=_.toArray(arguments);console.debug.apply(console,_.map(args,BiwaScheme.inspect))};BiwaScheme.max_trace_size=40;BiwaScheme.suppress_deprecation_warning=false;BiwaScheme.Class={create:function(methods){var klass=function(){this.initialize.apply(this,arguments)};_.extend(klass.prototype,methods);return klass},extend:function(parent,methods){var klass=function(){this.initialize.apply(this,arguments)};klass.prototype=parent;_.extend(klass.prototype,methods);return klass}};BiwaScheme.Class.memoize=function(klass,name_or_names){var proto=klass.prototype;var names=_.isArray(name_or_names)?name_or_names:[name_or_names];_.each(names,function(name){proto["compute_"+name]=proto[name];proto[name]=function(){if(!this.hasOwnProperty("cached_"+name)){this["cached_"+name]=this["compute_"+name].apply(this,_.toArray(arguments))}return this["cached_"+name]}})};BiwaScheme.to_write=function(obj){if(obj===undefined)return"undefined";else if(obj===null)return"null";else if(_.isFunction(obj))return"#<Function "+(obj.fname?obj.fname:obj.toSource?_.str.truncate(obj.toSource(),40):"")+">";else if(_.isString(obj))return'"'+obj.replace(/\\|\"/g,function($0){return"\\"+$0}).replace(/\x07/g,"\\a").replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\v/g,"\\v").replace(/\f/g,"\\f").replace(/\r/g,"\\r")+'"';else if(_.isArray(obj)&&obj.closure_p)return"#<Closure>";else if(_.isArray(obj))return"#("+_.map(obj,function(e){return BiwaScheme.to_write(e)}).join(" ")+")";else if(typeof obj.to_write=="function")return obj.to_write();else if(isNaN(obj)&&typeof obj=="number")return"+nan.0";else{switch(obj){case true:return"#t";case false:return"#f";case Infinity:return"+inf.0";case-Infinity:return"-inf.0"}}return BiwaScheme.inspect(obj)};BiwaScheme.to_display=function(obj){if(typeof obj.valueOf()=="string")return obj;else if(obj instanceof BiwaScheme.Symbol)return obj.name;else if(obj instanceof Array)return"#("+_.map(obj,BiwaScheme.to_display).join(" ")+")";else if(obj instanceof BiwaScheme.Pair)return obj.inspect(BiwaScheme.to_display);else if(obj instanceof BiwaScheme.Char)return obj.value;else return BiwaScheme.to_write(obj)};BiwaScheme.write_ss=function(obj,array_mode){var known=[obj],used=[false];BiwaScheme.find_cyclic(obj,known,used);var cyclic=BiwaScheme.reduce_cyclic_info(known,used);var appeared=new Array(cyclic.length);for(var i=cyclic.length-1;i>=0;i--)appeared[i]=false;return BiwaScheme.to_write_ss(obj,cyclic,appeared,array_mode)};BiwaScheme.to_write_ss=function(obj,cyclic,appeared,array_mode){var ret="";var i=cyclic.indexOf(obj);if(i>=0){if(appeared[i]){return"#"+i+"#"}else{appeared[i]=true;ret="#"+i+"="}}if(obj instanceof BiwaScheme.Pair){var a=[];a.push(BiwaScheme.to_write_ss(obj.car,cyclic,appeared,array_mode));for(var o=obj.cdr;o!=BiwaScheme.nil;o=o.cdr){if(!(o instanceof BiwaScheme.Pair)||cyclic.indexOf(o)>=0){a.push(".");a.push(BiwaScheme.to_write_ss(o,cyclic,appeared,array_mode));break}a.push(BiwaScheme.to_write_ss(o.car,cyclic,appeared,array_mode))}ret+="("+a.join(" ")+")"}else if(obj instanceof Array){var a=_.map(obj,function(item){return BiwaScheme.to_write_ss(item,cyclic,appeared,array_mode)});if(array_mode)ret+="["+a.join(", ")+"]";else ret+="#("+a.join(" ")+")"}else{ret+=BiwaScheme.to_write(obj)}return ret};BiwaScheme.reduce_cyclic_info=function(known,used){var n_used=0;for(var i=0;i<used.length;i++){if(used[i]){known[n_used]=known[i];n_used++}}return known.slice(0,n_used)};BiwaScheme.find_cyclic=function(obj,known,used){var items=obj instanceof BiwaScheme.Pair?[obj.car,obj.cdr]:obj instanceof Array?obj:null;if(!items)return;_.each(items,function(item){if(typeof item=="number"||typeof item=="string"||item===BiwaScheme.undef||item===true||item===false||item===BiwaScheme.nil||item instanceof BiwaScheme.Symbol)return;var i=known.indexOf(item);if(i>=0)used[i]=true;else{known.push(item);used.push(false);BiwaScheme.find_cyclic(item,known,used)}})};BiwaScheme.inspect=function(object,opts){try{if(_.isUndefined(object))return"undefined";if(object===null)return"null";if(object===true)return"#t";if(object===false)return"#f";if(object.inspect)return object.inspect();if(_.isString(object)){return'"'+object.replace(/"/g,'\\"')+'"'}if(_.isArray(object)){return"["+_.map(object,BiwaScheme.inspect).join(", ")+"]"}if(opts&&opts["fallback"]){return opts["fallback"]}else{return object.toString()}}catch(e){if(e instanceof RangeError)return"...";throw e}};BiwaScheme.isNil=function(obj){return obj===BiwaScheme.nil};BiwaScheme.isUndef=function(obj){return obj===BiwaScheme.undef};BiwaScheme.isChar=function(obj){return obj instanceof BiwaScheme.Char};BiwaScheme.isSymbol=function(obj){return obj instanceof BiwaScheme.Symbol};BiwaScheme.isPort=function(obj){return obj instanceof BiwaScheme.Port};BiwaScheme.isPair=function(obj){return obj instanceof BiwaScheme.Pair};BiwaScheme.isList=function(obj){var nil=BiwaScheme.nil,Pair=BiwaScheme.Pair;if(obj===nil){return true}if(!(obj instanceof Pair)){return false}var tortoise=obj;var hare=obj.cdr;while(true){if(hare===nil){return true}if(hare===tortoise){return false}if(!(hare instanceof Pair)){return false}if(hare.cdr===nil){return true}if(!(hare.cdr instanceof Pair)){return false}hare=hare.cdr.cdr;tortoise=tortoise.cdr}};BiwaScheme.isVector=function(obj){return obj instanceof Array&&obj.closure_p!==true};BiwaScheme.isHashtable=function(obj){return obj instanceof BiwaScheme.Hashtable};BiwaScheme.isMutableHashtable=function(obj){return obj instanceof BiwaScheme.Hashtable&&obj.mutable};BiwaScheme.isClosure=function(obj){return obj instanceof Array&&obj.closure_p===true};BiwaScheme.isProcedure=function(obj){return BiwaScheme.isClosure(obj)||_.isFunction(obj)};BiwaScheme.Error=BiwaScheme.Class.create({initialize:function(msg){this.message="Error: "+msg},toString:function(){return this.message}});BiwaScheme.Bug=BiwaScheme.Class.extend(new BiwaScheme.Error,{initialize:function(msg){this.message="[BUG] "+msg}});BiwaScheme.UserError=BiwaScheme.Class.extend(new BiwaScheme.Error,{initialize:function(msg){this.message=msg}});BiwaScheme.Set=BiwaScheme.Class.create({initialize:function(){this.arr=[];var i;for(i=0;i<arguments.length;i++)this.arr[i]=arguments[i]},equals:function(other){if(this.arr.length!=other.arr.length)return false;var a1=_.clone(this.arr);var a2=_.clone(other.arr);a1.sort();a2.sort();for(var i=0;i<this.arr.length;i++){if(a1[i]!=a2[i])return false}return true},set_cons:function(item){var o=new BiwaScheme.Set(item);o.arr=_.clone(this.arr);o.arr.push(item);return o},set_union:function(){var o=new BiwaScheme.Set;o.arr=_.clone(this.arr);for(var k=0;k<arguments.length;k++){var s2=arguments[k];if(!(s2 instanceof BiwaScheme.Set))throw new BiwaScheme.Error("set_union: arguments must be a set");for(var i=0;i<s2.arr.length;i++)o.add(s2.arr[i])}return o},set_intersect:function(s2){if(!(s2 instanceof BiwaScheme.Set))throw new BiwaScheme.Error("set_intersect: arguments must be a set");var o=new BiwaScheme.Set;for(var i=0;i<this.arr.length;i++)if(s2.member(this.arr[i]))o.add(this.arr[i]);return o},set_minus:function(s2){if(!(s2 instanceof BiwaScheme.Set))throw new BiwaScheme.Error("set_minus: arguments must be a set");var o=new BiwaScheme.Set;for(var i=0;i<this.arr.length;i++)if(!s2.member(this.arr[i]))o.add(this.arr[i]);return o},add:function(item){if(!this.member(item)){this.arr.push(item)}},member:function(item){for(var i=0;i<this.arr.length;i++)if(this.arr[i]==item)return true;return false},rindex:function(item){for(var i=this.arr.length-1;i>=0;i--)if(this.arr[i]==item)return this.arr.length-1-i;return null},index:function(item){for(var i=0;i<this.arr.length;i++)if(this.arr[i]==item)return i;return null},inspect:function(){return"Set("+this.arr.join(", ")+")"},toString:function(){return this.inspect()},size:function(){return this.arr.length}});BiwaScheme.Values=BiwaScheme.Class.create({initialize:function(values){this.content=values},to_write:function(){return"#<Values "+_.map(this.content,BiwaScheme.to_write).join(" ")+">"}});BiwaScheme.Pair=BiwaScheme.Class.create({initialize:function(car,cdr){this.car=car;this.cdr=cdr},caar:function(){return this.car.car},cadr:function(){return this.cdr.car},cdar:function(){return this.cdr.car},cddr:function(){return this.cdr.cdr},first:function(){return this.car},second:function(){return this.cdr.car},third:function(){return this.cdr.cdr.car},fourth:function(){return this.cdr.cdr.cdr.car},fifth:function(){return this.cdr.cdr.cdr.cdr.car},to_array:function(){var ary=[];for(var o=this;o instanceof BiwaScheme.Pair;o=o.cdr){ary.push(o.car)}return ary},to_set:function(){var set=new BiwaScheme.Set;for(var o=this;o instanceof BiwaScheme.Pair;o=o.cdr){set.add(o.car)}return set},length:function(){var n=0;for(var o=this;o instanceof BiwaScheme.Pair;o=o.cdr){n++}return n},foreach:function(func){for(var o=this;o instanceof BiwaScheme.Pair;o=o.cdr){func(o.car)}return o},map:function(func){var ary=[];for(var o=this;BiwaScheme.isPair(o);o=o.cdr){ary.push(func(o.car))}return ary},concat:function(list){var o=this;while(o instanceof BiwaScheme.Pair&&o.cdr!=BiwaScheme.nil){o=o.cdr}o.cdr=list;return this},inspect:function(conv){conv||(conv=BiwaScheme.inspect);var a=[];var last=this.foreach(function(o){a.push(conv(o))});if(last!=BiwaScheme.nil){a.push(".");a.push(conv(last))}return"("+a.join(" ")+")"},toString:function(){return this.inspect()},to_write:function(){return this.inspect(BiwaScheme.to_write)}});var array_to_list=function(ary,deep){var list=BiwaScheme.nil;for(var i=ary.length-1;i>=0;i--){var obj=ary[i];if(deep&&_.isArray(obj)&&!obj.is_vector){obj=array_to_list(obj,deep)}list=new BiwaScheme.Pair(obj,list)}return list};BiwaScheme.List=function(){var ary=_.toArray(arguments);return array_to_list(ary,false)};BiwaScheme.array_to_list=function(ary){return array_to_list(ary,false)};BiwaScheme.deep_array_to_list=function(ary){return array_to_list(ary,true)};BiwaScheme.Symbol=BiwaScheme.Class.create({initialize:function(str){this.name=str;BiwaScheme.Symbols[str]=this},inspect:function(){return"'"+this.name},toString:function(){return"'"+this.name},to_write:function(){return this.name}});BiwaScheme.Symbols={};BiwaScheme.Sym=function(name,leaveCase){if(BiwaScheme.Symbols[name]===undefined){return new BiwaScheme.Symbol(name)}else if(!(BiwaScheme.Symbols[name]instanceof BiwaScheme.Symbol)){return new BiwaScheme.Symbol(name)}else{return BiwaScheme.Symbols[name]}};BiwaScheme.gensym=function(){return BiwaScheme.Sym(_.uniqueId("__gensym"))};BiwaScheme.Char=BiwaScheme.Class.create({initialize:function(c){BiwaScheme.Chars[this.value=c]=this},to_write:function(){switch(this.value){case"\n":return"#\\newline";case" ":return"#\\space";case"	":return"#\\tab";default:return"#\\"+this.value}},inspect:function(){return this.to_write()}});BiwaScheme.Chars={};BiwaScheme.Char.get=function(c){if(typeof c!="string"){throw new BiwaScheme.Bug("Char.get: "+BiwaScheme.inspect(c)+" is not a string")}if(BiwaScheme.Chars[c]===undefined)return new BiwaScheme.Char(c);else return BiwaScheme.Chars[c]};BiwaScheme.Complex=BiwaScheme.Class.create({initialize:function(real,imag){this.real=real;this.imag=imag},magnitude:function(){return Math.sqrt(this.real*this.real+this.imag*this.imag)},angle:function(){return Math.acos(this.real/this.magnitude())}});BiwaScheme.Complex.from_polar=function(r,theta){var real=r*Math.cos(theta);var imag=r*Math.sin(theta);return new BiwaScheme.Complex(real,imag)};BiwaScheme.Complex.assure=function(num){if(num instanceof BiwaScheme.Complex)return num;else return new BiwaScheme.Complex(num,0)};BiwaScheme.Rational=BiwaScheme.Class.create({initialize:function(numerator,denominator){this.numerator=numerator;this.denominator=denominator}});BiwaScheme.eof=new Object;BiwaScheme.Port=BiwaScheme.Class.create({initialize:function(is_in,is_out){this.is_open=true;this.is_binary=false;this.is_input=is_in;this.is_output=is_out},close:function(){this.is_open=false},inspect:function(){return"#<Port>"},to_write:function(){return"#<Port>"}});BiwaScheme.Port.BrowserInput=BiwaScheme.Class.extend(new BiwaScheme.Port(true,false),{initialize:function(){},get_string:function(after){var form=$("<form/>");form.html("<input id='webscheme-read-line' type='text'><input type='submit' value='ok'>");$("#bs-console").append(form);return new BiwaScheme.Pause(function(pause){form.submit(function(){var input=$("#webscheme-read-line").val();form.remove();puts(input);pause.resume(after(input));return false})})}});BiwaScheme.Port.DefaultOutput=BiwaScheme.Class.extend(new BiwaScheme.Port(false,true),{initialize:function(){},put_string:function(str){puts(str,true)}});BiwaScheme.Port.StringOutput=BiwaScheme.Class.extend(new BiwaScheme.Port(false,true),{initialize:function(){this.buffer=[]},put_string:function(str){this.buffer.push(str)},output_string:function(str){return this.buffer.join("")}});BiwaScheme.Port.StringInput=BiwaScheme.Class.extend(new BiwaScheme.Port(true,false),{initialize:function(str){this.str=str},get_string:function(after){return after(this.str)}});BiwaScheme.Port.current_input=new BiwaScheme.Port.BrowserInput;BiwaScheme.Port.current_output=new BiwaScheme.Port.DefaultOutput;BiwaScheme.Port.current_error=new BiwaScheme.Port.DefaultOutput;BiwaScheme.Record=BiwaScheme.Class.create({initialize:function(rtd,values){BiwaScheme.assert_record_td(rtd,"new Record");this.rtd=rtd;this.fields=values},get:function(k){return this.fields[k]},set:function(k,v){this.fields[k]=v},toString:function(){var contents=BiwaScheme.to_write(this.fields);return"#<Record "+this.rtd.name+" "+contents+">"}});BiwaScheme.isRecord=function(o){return o instanceof BiwaScheme.Record};BiwaScheme.Record._DefinedTypes={};BiwaScheme.Record.define_type=function(name_str,rtd,cd){return BiwaScheme.Record._DefinedTypes[name_str]={rtd:rtd,cd:cd}};BiwaScheme.Record.get_type=function(name_str){return BiwaScheme.Record._DefinedTypes[name_str]};BiwaScheme.Record.RTD=BiwaScheme.Class.create({initialize:function(name,parent_rtd,uid,sealed,opaque,fields){this.name=name;this.parent_rtd=parent_rtd;this.is_base_type=!parent_rtd;if(uid){this.uid=uid;this.generative=false}else{this.uid=this._generate_new_uid();this.generative=true}this.sealed=!!sealed;this.opaque=parent_rtd.opaque||!!opaque;this.fields=_.map(fields,function(field){return{name:field[0],mutable:!!field[1]}})},field_name:function(k){var names=this._field_names();for(par=this.parent_rtd;par;par=par.parent_rtd){names=par._field_names()+names}return names[k]},_field_names:function(){return _.map(this.fields,function(spec){return spec.name})},_generate_new_uid:function(){return BiwaScheme.Sym(_.uniqueId("__record_td_uid"))},toString:function(){return"#<RecordTD "+name+">"}});BiwaScheme.Record.RTD.NongenerativeRecords={};BiwaScheme.isRecordTD=function(o){return o instanceof BiwaScheme.Record.RTD};BiwaScheme.Record.CD=BiwaScheme.Class.create({initialize:function(rtd,parent_cd,protocol){this._check(rtd,parent_cd,protocol);this.rtd=rtd;this.parent_cd=parent_cd;if(protocol){this.has_custom_protocol=true;this.protocol=protocol}else{this.has_custom_protocol=false;if(rtd.parent_rtd)this.protocol=this._default_protocol_for_derived_types();else this.protocol=this._default_protocol_for_base_types()}},_check:function(rtd,parent_cd,protocol){if(rtd.is_base_type&&parent_cd)throw new Error("Record.CD.new: cannot specify parent cd of a base type");if(parent_cd&&rtd.parent_rtd&&parent_cd.rtd!=rtd.parent_rtd)throw new Error("Record.CD.new: mismatched parents between rtd and parent_cd");if(rtd.parent_rtd&&!parent_cd&&protocol)throw new Error("Record.CD.new: protocol must be #f when parent_cd is not given");if(parent_cd&&parent_cd.has_custom_protocol&&!protocol)throw new Error("Record.CD.new: protocol must be specified when parent_cd has a custom protocol")},_default_protocol_for_base_types:function(){return function(ar){var p=ar[0];BiwaScheme.assert_procedure(p,"_default_protocol/base");return p}},_default_protocol_for_derived_types:function(){var rtd=this.rtd;return function(ar){var n=ar[0];BiwaScheme.assert_procedure(n,"_default_protocol/n");var ctor=function(args){var my_argc=rtd.fields.length;var ancestor_argc=args.length-my_argc;var ancestor_values=args.slice(0,ancestor_argc);var my_values=args.slice(ancestor_argc);return new BiwaScheme.Call(n,ancestor_values,function(ar){var p=ar[0];BiwaScheme.assert_procedure(p,"_default_protocol/p");return new BiwaScheme.Call(p,my_values,function(ar){var record=ar[0];BiwaScheme.assert_record(record,"_default_protocol/result");return record})})};return ctor}},toString:function(){return"#<RecordCD "+this.rtd.name+">"},record_constructor:function(){var arg_for_protocol=this.parent_cd?this._make_n([],this.rtd):this._make_p();arg_for_protocol=_.bind(arg_for_protocol,this);return new BiwaScheme.Call(this.protocol,[arg_for_protocol],function(ar){var ctor=ar[0];BiwaScheme.assert_procedure(ctor,"record_constructor");return ctor})},_make_p:function(){return function(values){return new BiwaScheme.Record(this.rtd,values)}},_make_n:function(children_values,rtd){var parent_cd=this.parent_cd;if(parent_cd){var n=function(args_for_n){var p=function(args_for_p){var values=[].concat(args_for_p[0]).concat(children_values);var parent_n=parent_cd._make_n(values,rtd);return new BiwaScheme.Call(parent_cd.protocol,[parent_n],function(ar){var ctor=ar[0];BiwaScheme.assert_procedure(ctor,"_make_n");return new BiwaScheme.Call(ctor,args_for_n,function(ar){var record=ar[0];BiwaScheme.assert_record(record);return record})})};return p};return n}else{var n=function(my_values){var values=my_values.concat(children_values);return new BiwaScheme.Record(rtd,values)};return n}}});BiwaScheme.isRecordCD=function(o){return o instanceof BiwaScheme.Record.CD};BiwaScheme.Enumeration={};BiwaScheme.Enumeration.EnumType=BiwaScheme.Class.create({initialize:function(members){this.members=_.uniq(members)},universe:function(){return new BiwaScheme.Enumeration.EnumSet(this,this.members)},indexer:function(){return _.bind(function(ar){BiwaScheme.assert_symbol(ar[0],"(enum-set indexer)");var idx=_.indexOf(this.members,ar[0]);return idx===-1?false:idx},this)},constructor:function(){return _.bind(function(ar){BiwaScheme.assert_list(ar[0],"(enum-set constructor)");var symbols=ar[0].to_array();_.each(symbols,function(arg){BiwaScheme.assert_symbol(arg,"(enum-set constructor)")});return new BiwaScheme.Enumeration.EnumSet(this,symbols)},this)}});BiwaScheme.Class.memoize(BiwaScheme.Enumeration.EnumType,["universe","indexer","constructor"]);BiwaScheme.Enumeration.EnumSet=BiwaScheme.Class.create({initialize:function(enum_type,symbols){this.enum_type=enum_type;this.symbols=_.filter(enum_type.members,function(sym){return _.include(symbols,sym)})},symbol_list:function(){return BiwaScheme.array_to_list(this.symbols)},is_member:function(symbol){return _.include(this.symbols,symbol)},is_subset:function(other){if(_.any(this.symbols,function(sym){return!_.include(other.symbols,sym)})){return false}if(this.enum_type===other.enum_type){return true}else{return _.all(this.enum_type.members,function(sym){return _.include(other.enum_type.members,sym)})}},equal_to:function(other){return this.is_subset(other)&&other.is_subset(this)},union:function(other){var syms=_.filter(this.enum_type.members,_.bind(function(sym){return _.include(this.symbols,sym)||_.include(other.symbols,sym)},this));return new BiwaScheme.Enumeration.EnumSet(this.enum_type,syms)},intersection:function(other){var syms=_.filter(this.symbols,function(sym){return _.include(other.symbols,sym)});return new BiwaScheme.Enumeration.EnumSet(this.enum_type,syms)},difference:function(other){var syms=_.filter(this.symbols,function(sym){return!_.include(other.symbols,sym)});return new BiwaScheme.Enumeration.EnumSet(this.enum_type,syms)},complement:function(){var syms=_.filter(this.enum_type.members,_.bind(function(sym){return!_.include(this.symbols,sym)},this));return new BiwaScheme.Enumeration.EnumSet(this.enum_type,syms)},projection:function(other){var syms=_.filter(this.symbols,function(sym){return _.include(other.enum_type.members,sym)});return new BiwaScheme.Enumeration.EnumSet(other.enum_type,syms)},toString:function(){return"#<EnumSet "+BiwaScheme.inspect(this.symbols)+">"}});BiwaScheme.Class.memoize(BiwaScheme.Enumeration.EnumSet,"symbol_list");BiwaScheme.isEnumSet=function(obj){return obj instanceof BiwaScheme.Enumeration.EnumSet};BiwaScheme.Hashtable=BiwaScheme.Class.create({initialize:function(_hash_proc,_equiv_proc,mutable){this.mutable=mutable===undefined?true:mutable?true:false;this.hash_proc=_hash_proc;this.equiv_proc=_equiv_proc;this.pairs_of={}},clear:function(){this.pairs_of={}},candidate_pairs:function(hashed){return this.pairs_of[hashed]},add_pair:function(hashed,key,value){var pairs=this.pairs_of[hashed];if(pairs){pairs.push([key,value])}else{this.pairs_of[hashed]=[[key,value]]}},remove_pair:function(hashed,pair){var pairs=this.pairs_of[hashed];var i=pairs.indexOf(pair);if(i==-1){throw new BiwaScheme.Bug("Hashtable#remove_pair: pair not found!")}else{pairs.splice(i,1)}},create_copy:function(mutable){var copy=new BiwaScheme.Hashtable(this.hash_proc,this.equiv_proc,mutable);_.each(_.keys(this.pairs_of),_.bind(function(hashed){var pairs=this.pairs_of[hashed];var cloned=_.map(pairs,function(pair){return _.clone(pair)});copy.pairs_of[hashed]=cloned},this));return copy},size:function(){var n=0;this._apply_pair(function(pair){n++});return n},keys:function(){return this._apply_pair(function(pair){return pair[0]})},values:function(){return this._apply_pair(function(pair){return pair[1]})},_apply_pair:function(func){var a=[];_.each(_.values(this.pairs_of),function(pairs){_.each(pairs,function(pair){a.push(func(pair))})});return a},to_write:function(){return"#<Hashtable size="+this.size()+">"}});BiwaScheme.Hashtable.equal_hash=function(ar){return BiwaScheme.to_write(ar[0])};BiwaScheme.Hashtable.eq_hash=BiwaScheme.Hashtable.equal_hash;BiwaScheme.Hashtable.eqv_hash=BiwaScheme.Hashtable.equal_hash;BiwaScheme.Hashtable.string_hash=function(ar){return ar[0]};BiwaScheme.Hashtable.string_ci_hash=function(ar){return _.isString(ar[0])?ar[0].toLowerCase():ar[0]};BiwaScheme.Hashtable.symbol_hash=function(ar){return ar[0]instanceof BiwaScheme.Symbol?ar[0].name:ar[0]};BiwaScheme.Hashtable.eq_equiv=function(ar){return BiwaScheme.eq(ar[0],ar[1])};BiwaScheme.Hashtable.eqv_equiv=function(ar){return BiwaScheme.eqv(ar[0],ar[1])};BiwaScheme.Syntax=BiwaScheme.Class.create({initialize:function(sname,func){this.sname=sname;this.func=func},transform:function(x){if(!this.func){throw new BiwaScheme.Bug("sorry, syntax "+this.sname+" is a pseudo syntax now")}return this.func(x)},inspect:function(){return"#<Syntax "+this.sname+">"}});BiwaScheme.TopEnv["define"]=new BiwaScheme.Syntax("define");BiwaScheme.TopEnv["begin"]=new BiwaScheme.Syntax("begin");BiwaScheme.TopEnv["quote"]=new BiwaScheme.Syntax("quote");BiwaScheme.TopEnv["lambda"]=new BiwaScheme.Syntax("lambda");BiwaScheme.TopEnv["if"]=new BiwaScheme.Syntax("if");BiwaScheme.TopEnv["set!"]=new BiwaScheme.Syntax("set!");BiwaScheme.Parser=BiwaScheme.Class.create({initialize:function(txt){this.tokens=this.tokenize(txt);this.i=0},inspect:function(){return["#<Parser:",this.i,"/",this.tokens.length," ",BiwaScheme.inspect(this.tokens),">"].join("")},tokenize:function(txt){var tokens=new Array,oldTxt=null;var in_srfi_30_comment=0;while(txt!=""&&oldTxt!=txt){oldTxt=txt;txt=txt.replace(/^\s*(;[^\r\n]*(\r|\n|$)|#;|#\||#\\[^\w]|#?(\(|\[|{)|\)|\]|}|\'|`|,@|,|\+inf\.0|-inf\.0|\+nan\.0|\"(\\(.|$)|[^\"\\])*(\"|$)|[^\s()\[\]{}]+)/,function($0,$1){var t=$1;if(t=="#|"){in_srfi_30_comment++;return""}else if(in_srfi_30_comment>0){if(/(.*\|#)/.test(t)){in_srfi_30_comment--;if(in_srfi_30_comment<0){throw new BiwaScheme.Error("Found an extra comment terminator: `|#'")}return t.substring(RegExp.$1.length,t.length)}else{return""}}else{if(t.charAt(0)!=";")tokens[tokens.length]=t;return""}})}return tokens},sexpCommentMarker:new Object,getObject:function(){var r=this.getObject0();if(r!=this.sexpCommentMarker)return r;r=this.getObject();if(r==BiwaScheme.Parser.EOS)throw new BiwaScheme.Error("Readable object not found after S exression comment");r=this.getObject();return r},getList:function(close){var list=BiwaScheme.nil,prev=list;while(this.i<this.tokens.length){this.eatObjectsInSexpComment("Input stream terminated unexpectedly(in list)");if(this.tokens[this.i]==")"||this.tokens[this.i]=="]"||this.tokens[this.i]=="}"){this.i++;break}if(this.tokens[this.i]=="."){this.i++;var o=this.getObject();if(o!=BiwaScheme.Parser.EOS&&list!=BiwaScheme.nil){prev.cdr=o}}else{var cur=new BiwaScheme.Pair(this.getObject(),BiwaScheme.nil);if(list==BiwaScheme.nil)list=cur;else prev.cdr=cur;prev=cur}}return list},getVector:function(close){var arr=new Array;while(this.i<this.tokens.length){this.eatObjectsInSexpComment("Input stream terminated unexpectedly(in vector)");if(this.tokens[this.i]==")"||this.tokens[this.i]=="]"||this.tokens[this.i]=="}"){this.i++;break}arr[arr.length]=this.getObject()}return arr},eatObjectsInSexpComment:function(err_msg){while(this.tokens[this.i]=="#;"){this.i++;if(this.getObject()==BiwaScheme.Parser.EOS||this.i>=this.tokens.length)throw new BiwaScheme.Error(err_msg)}},getObject0:function(){if(this.i>=this.tokens.length)return BiwaScheme.Parser.EOS;var t=this.tokens[this.i++];if(t=="#;")return this.sexpCommentMarker;var s=t=="'"?"quote":t=="`"?"quasiquote":t==","?"unquote":t==",@"?"unquote-splicing":false;if(s||t=="("||t=="#("||t=="["||t=="#["||t=="{"||t=="#{"){return s?new BiwaScheme.Pair(BiwaScheme.Sym(s),new BiwaScheme.Pair(this.getObject(),BiwaScheme.nil)):t=="("||t=="["||t=="{"?this.getList(t):this.getVector(t)}else{switch(t){case"+inf.0":return Infinity;case"-inf.0":return-Infinity;case"+nan.0":return NaN}var n;if(/^#x[0-9a-z]+$/i.test(t)){n=new Number("0x"+t.substring(2,t.length))}else if(/^#d[0-9\.]+$/i.test(t)){n=new Number(t.substring(2,t.length))}else{n=new Number(t)}if(!isNaN(n)){return n.valueOf()}else if(t=="#f"||t=="#F"){return false}else if(t=="#t"||t=="#T"){return true}else if(t.toLowerCase()=="#\\newline"){return BiwaScheme.Char.get("\n")}else if(t.toLowerCase()=="#\\space"){return BiwaScheme.Char.get(" ")}else if(t.toLowerCase()=="#\\tab"){return BiwaScheme.Char.get("	")}else if(/^#\\.$/.test(t)){return BiwaScheme.Char.get(t.charAt(2))}else if(/^#\\x[a-zA-Z0-9]+$/.test(t)){var scalar=parseInt(t.slice(3),16);if(scalar>=55296&&scalar<=57343){throw new BiwaScheme.Error("Character in Unicode excluded range.")}else if(scalar>65535){throw new BiwaScheme.Error("Character literal out of range.")}else{return BiwaScheme.Char.get(String.fromCharCode(scalar))}}else if(/^\"(\\(.|$)|[^\"\\])*\"?$/.test(t)){return t.replace(/(\r?\n|\\n)/g,"\n").replace(/^\"|\\(.|$)|\"$/g,function($0,$1){return $1?$1:""})}else return BiwaScheme.Sym(t)}}});BiwaScheme.Parser.EOS=new Object;BiwaScheme.Compiler=BiwaScheme.Class.create({initialize:function(){},is_tail:function(x){return x[0]=="return"},collect_free:function(free,e,next){var vars=free;var opc=next;var arr=vars.arr;for(var i=0;i<arr.length;i++){opc=this.compile_refer(arr[i],e,["argument",opc])}return opc},compile_refer:function(x,e,next){return this.compile_lookup(x,e,function(n){return["refer-local",n,next]},function(n){return["refer-free",n,next]},function(sym){return["refer-global",sym,next]})},compile_lookup:function(x,e,return_local,return_free,return_global){var locals=e[0],free=e[1];if((n=locals.index(x))!=null){return return_local(n)}else if((n=free.index(x))!=null){return return_free(n)}else{var sym=x.name;return return_global(sym)}},make_boxes:function(sets,vars,next){var vars=vars;var n=0;var a=[];while(vars instanceof BiwaScheme.Pair){if(sets.member(vars.car))a.push(n);n++;vars=vars.cdr}var opc=next;for(var i=a.length-1;i>=0;i--)opc=["box",a[i],opc];return opc},find_sets:function(x,v){var ret=null;if(x instanceof BiwaScheme.Symbol){ret=new BiwaScheme.Set}else if(x instanceof BiwaScheme.Pair){switch(x.first()){case BiwaScheme.Sym("define"):var exp=x.third();ret=this.find_sets(exp,v);case BiwaScheme.Sym("begin"):ret=this.find_sets(x.cdr,v);break;case BiwaScheme.Sym("quote"):ret=new BiwaScheme.Set;break;case BiwaScheme.Sym("lambda"):var vars=x.second(),body=x.cdr.cdr;if(vars instanceof BiwaScheme.Pair){ret=this.find_sets(body,v.set_minus(vars.to_set()))}else{ret=this.find_sets(body,v.set_minus(new BiwaScheme.Set(vars)))}break;case BiwaScheme.Sym("if"):var testc=x.second(),thenc=x.third(),elsec=x.fourth();ret=this.find_sets(testc,v).set_union(this.find_sets(thenc,v),this.find_sets(elsec,v));break;case BiwaScheme.Sym("set!"):var vari=x.second(),xx=x.third();if(v.member(vari))ret=this.find_sets(xx,v).set_cons(vari);else ret=this.find_sets(xx,v);break;case BiwaScheme.Sym("call/cc"):var exp=x.second();ret=this.find_sets(exp,v);break;default:var set=new BiwaScheme.Set;for(var p=x;p instanceof BiwaScheme.Pair;p=p.cdr){set=set.set_union(this.find_sets(p.car,v))}ret=set;break}}else{ret=new BiwaScheme.Set}if(ret==null)throw new BiwaScheme.Bug("find_sets() exited in unusual way");else return ret},find_free:function(x,b,f){var ret=null;if(x instanceof BiwaScheme.Symbol){if(f.member(x))ret=new BiwaScheme.Set(x);else ret=new BiwaScheme.Set}else if(x instanceof BiwaScheme.Pair){switch(x.first()){case BiwaScheme.Sym("define"):var exp=x.third();ret=this.find_free(exp,b,f);break;case BiwaScheme.Sym("begin"):ret=this.find_free(x.cdr,b,f);break;case BiwaScheme.Sym("quote"):ret=new BiwaScheme.Set;break;case BiwaScheme.Sym("lambda"):var vars=x.second(),body=x.cdr.cdr;if(vars instanceof BiwaScheme.Pair){ret=this.find_free(body,b.set_union(vars.to_set()),f)}else{ret=this.find_free(body,b.set_cons(vars),f)}break;case BiwaScheme.Sym("if"):var testc=x.second(),thenc=x.third(),elsec=x.fourth();ret=this.find_free(testc,b,f).set_union(this.find_free(thenc,b,f),this.find_free(elsec,b,f));break;case BiwaScheme.Sym("set!"):var vari=x.second(),exp=x.third();if(f.member(vari))ret=this.find_free(exp,b,f).set_cons(vari);else ret=this.find_free(exp,b,f);break;case BiwaScheme.Sym("call/cc"):var exp=x.second();ret=this.find_free(exp,b,f);break;default:var set=new BiwaScheme.Set;for(var p=x;p instanceof BiwaScheme.Pair;p=p.cdr){set=set.set_union(this.find_free(p.car,b,f))}ret=set;break}}else{ret=new BiwaScheme.Set}if(ret==null)throw new BiwaScheme.Bug("find_free() exited in unusual way");else return ret},find_dot_pos:function(x){var idx=0;for(;x instanceof BiwaScheme.Pair;x=x.cdr,++idx);if(x!=BiwaScheme.nil){return idx}else{return-1}},last_pair:function(x){if(x instanceof BiwaScheme.Pair){for(;x.cdr instanceof BiwaScheme.Pair;x=x.cdr);}return x},dotted2proper:function(ls){var nreverse=function(ls){var res=BiwaScheme.nil;for(;ls instanceof BiwaScheme.Pair;){var d=ls.cdr;ls.cdr=res;res=ls;ls=d}return res};var copy_list=function(ls){var res=BiwaScheme.nil;for(;ls instanceof BiwaScheme.Pair;ls=ls.cdr){res=new BiwaScheme.Pair(ls.car,res)}return nreverse(res)};if(ls instanceof BiwaScheme.Pair){var last=this.last_pair(ls);if(last instanceof BiwaScheme.Pair&&last.cdr===BiwaScheme.nil){return ls}else{var copied=copy_list(ls);this.last_pair(copied).cdr=new BiwaScheme.Pair(last.cdr,BiwaScheme.nil);return copied}}else{return new BiwaScheme.Pair(ls,BiwaScheme.nil)}},compile:function(x,e,s,f,next){var ret=null;while(1){if(x instanceof BiwaScheme.Symbol){return this.compile_refer(x,e,s.member(x)?["indirect",next]:next)}else if(x instanceof BiwaScheme.Pair){switch(x.first()){case BiwaScheme.Sym("define"):ret=this._compile_define(x,next);x=ret[0];next=ret[1];

break;case BiwaScheme.Sym("begin"):var a=[];for(var p=x.cdr;p instanceof BiwaScheme.Pair;p=p.cdr)a.push(p.car);var c=next;for(var i=a.length-1;i>=0;i--){c=this.compile(a[i],e,s,f,c)}return c;case BiwaScheme.Sym("quote"):if(x.length()<2)throw new BiwaScheme.Error("Invalid quote: "+x.to_write());var obj=x.second();return["constant",obj,next];case BiwaScheme.Sym("lambda"):return this._compile_lambda(x,e,s,f,next);case BiwaScheme.Sym("if"):if(x.length()<3||x.length()>4)throw new BiwaScheme.Error("Invalid if: "+x.to_write());var testc=x.second(),thenc=x.third(),elsec=x.fourth();var thenc=this.compile(thenc,e,s,f,next);var elsec=this.compile(elsec,e,s,f,next);x=testc;next=["test",thenc,elsec];break;case BiwaScheme.Sym("set!"):if(x.length()!=3)throw new BiwaScheme.Error("Invalid set!: "+x.to_write());var v=x.second(),x=x.third();var do_assign=this.compile_lookup(v,e,function(n){return["assign-local",n,next]},function(n){return["assign-free",n,next]},function(sym){return["assign-global",sym,next]});next=do_assign;break;case BiwaScheme.Sym("call/cc"):var x=x.second();var c=["conti",this.is_tail(next)?e[0].size()+1:0,["argument",["constant",1,["argument",this.compile(x,e,s,f,this.is_tail(next)?["shift",1,["tco_hinted_apply"]]:["apply"])]]]];return this.is_tail(next)?c:["frame",c,next];default:var func=x.car;var args=x.cdr;var c=this.compile(func,e,s,f,this.is_tail(next)?["shift",args.length(),["tco_hinted_apply"]]:["apply"]);c=this.compile(args.length(),e,s,f,["argument",c]);for(var p=args;p instanceof BiwaScheme.Pair;p=p.cdr){c=this.compile(p.car,e,s,f,["argument",c])}return this.is_tail(next)?c:["frame",c,next]}}else{return["constant",x,next]}}},_compile_define:function(x,next){if(x.length()==1){throw new BiwaScheme.Error("Invalid `define': "+x.to_write())}var first=x.cdr.car;var rest=x.cdr.cdr;if(first instanceof BiwaScheme.Symbol){if(rest===BiwaScheme.nil){x=BiwaScheme.undef}else{if(rest.cdr===BiwaScheme.nil)x=rest.car;else throw new BiwaScheme.Error("Invalid `define': "+x.to_write())}BiwaScheme.TopEnv[first.name]=BiwaScheme.undef;next=["assign-global",first.name,next]}else if(first instanceof BiwaScheme.Pair){var fname=first.car,args=first.cdr;var lambda=new BiwaScheme.Pair(BiwaScheme.Sym("lambda"),new BiwaScheme.Pair(args,rest));x=lambda;BiwaScheme.TopEnv[fname.name]=BiwaScheme.undef;next=["assign-global",fname.name,next]}else{throw new BiwaScheme.Error("define: symbol or pair expected but got "+first)}return[x,next]},_compile_lambda:function(x,e,s,f,next){if(x.length()<3)throw new BiwaScheme.Error("Invalid lambda: "+x.to_write());var vars=x.cdr.car;var body=x.cdr.cdr;var tbody=BiwaScheme.Compiler.transform_internal_define(body);if(BiwaScheme.isPair(tbody)&&BiwaScheme.isSymbol(tbody.car)&&tbody.car.name=="letrec*"){var cbody=BiwaScheme.Interpreter.expand(tbody)}else{var cbody=new BiwaScheme.Pair(BiwaScheme.Sym("begin"),x.cdr.cdr)}var dotpos=this.find_dot_pos(vars);var proper=this.dotted2proper(vars);var free=this.find_free(cbody,proper.to_set(),f);var sets=this.find_sets(cbody,proper.to_set());var do_body=this.compile(cbody,[proper.to_set(),free],sets.set_union(s.set_intersect(free)),f.set_union(proper.to_set()),["return"]);var do_close=["close",free.size(),this.make_boxes(sets,proper,do_body),next,dotpos];return this.collect_free(free,e,do_close)},run:function(expr){return this.compile(expr,[new BiwaScheme.Set,new BiwaScheme.Set],new BiwaScheme.Set,new BiwaScheme.Set,["halt"])}});BiwaScheme.Compiler.compile=function(expr,next){expr=BiwaScheme.Interpreter.expand(expr);return(new BiwaScheme.Compiler).run(expr,next)};(function(){var is_definition=function(x){return BiwaScheme.isPair(x)&&BiwaScheme.Sym("define")===x.car};var define_to_lambda_bind=function(def){var sig=def.cdr.car;var body=def.cdr.cdr;if(BiwaScheme.isSymbol(sig)){var variable=sig;return new BiwaScheme.Pair(variable,body)}else{var variable=sig.car;var value=new BiwaScheme.Pair(BiwaScheme.Sym("lambda"),new BiwaScheme.Pair(sig.cdr,body));return BiwaScheme.List(variable,value)}};BiwaScheme.Compiler.transform_internal_define=function(x){var defs=[],item=x;while(is_definition(item.car)){defs.push(item.car);item=item.cdr}var exprs=item;if(defs.length==0)return x;var bindings=BiwaScheme.List.apply(null,_.map(defs,define_to_lambda_bind));return new BiwaScheme.Pair(BiwaScheme.Sym("letrec*"),new BiwaScheme.Pair(bindings,exprs))}})();BiwaScheme.Pause=BiwaScheme.Class.create({initialize:function(on_pause){this.on_pause=on_pause},set_state:function(intp,x,f,c,s){this.interpreter=intp;this.x=x;this.f=f;this.c=c;this.s=s},ready:function(){this.on_pause(this)},resume:function(value){return this.interpreter.resume(true,value,this.x,this.f,this.c,this.s)}});BiwaScheme.Call=BiwaScheme.Class.create({initialize:function(proc,args,after){this.proc=proc;this.args=args;this.after=after||function(ar){return ar[0]}},inspect:function(){return"#<Call args="+this.args.inspect()+">"},toString:function(){return"#<Call>"},to_write:function(){return"#<Call>"}});BiwaScheme.Iterator={ForArray:BiwaScheme.Class.create({initialize:function(arr){this.arr=arr;this.i=0},has_next:function(){return this.i<this.arr.length},next:function(){return this.arr[this.i++]}}),ForString:BiwaScheme.Class.create({initialize:function(str){this.str=str;this.i=0},has_next:function(){return this.i<this.str.length},next:function(){return BiwaScheme.Char.get(this.str.charAt(this.i++))}}),ForList:BiwaScheme.Class.create({initialize:function(ls){this.ls=ls},has_next:function(){return this.ls instanceof BiwaScheme.Pair&&this.ls!=BiwaScheme.nil},next:function(){var pair=this.ls;this.ls=this.ls.cdr;return pair}}),ForMulti:BiwaScheme.Class.create({initialize:function(objs){this.objs=objs;this.size=objs.length;this.iterators=_.map(objs,function(x){return BiwaScheme.Iterator.of(x)})},has_next:function(){for(var i=0;i<this.size;i++)if(!this.iterators[i].has_next())return false;return true},next:function(){return _.map(this.iterators,function(ite){return ite.next()})}}),of:function(obj){switch(true){case obj instanceof Array:return new this.ForArray(obj);case typeof obj=="string":return new this.ForString(obj);case obj instanceof BiwaScheme.Pair:case obj===BiwaScheme.nil:return new this.ForList(obj);default:throw new BiwaScheme.Bug("Iterator.of: unknown class: "+BiwaScheme.inspect(obj))}}};BiwaScheme.Call.default_callbacks={call:function(x){return new BiwaScheme.Call(this.proc,[x])},result:function(){},finish:function(){}};BiwaScheme.Call.foreach=function(obj,callbacks,is_multi){is_multi||(is_multi=false);_.each(["call","result","finish"],function(key){if(!callbacks[key])callbacks[key]=BiwaScheme.Call.default_callbacks[key]});var iterator=null;var x=null;var loop=function(ar){if(iterator){var ret=callbacks["result"](ar[0],x);if(ret!==undefined)return ret}else{if(is_multi)iterator=new BiwaScheme.Iterator.ForMulti(obj);else iterator=BiwaScheme.Iterator.of(obj)}if(!iterator.has_next()){return callbacks["finish"]()}else{x=iterator.next();var result=callbacks["call"](x);result.after=loop;return result}};return loop(null)};BiwaScheme.Call.multi_foreach=function(obj,callbacks){return BiwaScheme.Call.foreach(obj,callbacks,true)};BiwaScheme.Interpreter=BiwaScheme.Class.create({initialize:function(){var last_interpreter=null;var on_error=null;if(arguments.length==2){last_interpreter=arguments[0];on_error=arguments[1]}else if(arguments.length==1&&arguments[0]instanceof BiwaScheme.Interpreter){last_interpreter=arguments[0]}else if(arguments.length==1&&typeof arguments[0]=="function"){on_error=arguments[0]}this.stack=[];this.on_error=on_error||(last_interpreter?last_interpreter.on_error:function(e){});this.after_evaluate=function(){};this.last_refer=last_interpreter?last_interpreter.last_refer:null;this.call_stack=last_interpreter?_.clone(last_interpreter.call_stack):[];this.tco_counter=[];this.max_trace_size=last_interpreter?last_interpreter.max_trace_size:BiwaScheme.max_trace_size},inspect:function(){return["#<Interpreter: stack size=>",this.stack.length," ","after_evaluate=",BiwaScheme.inspect(this.after_evaluate),">"].join("")},push:function(x,s){this.stack[s]=x;return s+1},save_stack:function(s){var v=[];for(var i=0;i<s;i++){v[i]=this.stack[i]}return{stack:v,last_refer:this.last_refer,call_stack:_.clone(this.call_stack),tco_counter:_.clone(this.tco_counter)}},restore_stack:function(stuff){v=stuff.stack;var s=v.length;for(var i=0;i<s;i++){this.stack[i]=v[i]}this.last_refer=stuff.last_refer;this.call_stack=_.clone(stuff.call_stack);this.tco_counter=_.clone(stuff.tco_counter);return s},continuation:function(s,n){var ss=this.push(n,s);return this.closure(["refer-local",0,["nuate",this.save_stack(ss),["return"]]],0,null,-1)},shift_args:function(n,m,s){for(var i=n-1;i>=-1;i--){this.index_set(s,i+m+1,this.index(s,i))}return s-m-1},index:function(s,i){return this.stack[s-i-2]},index_set:function(s,i,v){this.stack[s-i-2]=v},closure:function(body,n,s,dotpos){var v=[];v[0]=body;for(var i=0;i<n;i++)v[i+1]=this.index(s,i-1);v[n+1]=dotpos;v.closure_p=true;return v},execute:function(a,x,f,c,s){var ret=null;try{ret=this._execute(a,x,f,c,s)}catch(e){e.message=e.message+" ["+this.call_stack.join(", ")+"]";var state={a:a,x:x,f:f,c:c,s:s,stack:this.stack};return this.on_error(e,state)}return ret},run_dump_hook:function(a,x,f,c,s){var dumper;var state;if(this.dumper){dumper=this.dumper}else if(BiwaScheme.Interpreter.dumper){dumper=BiwaScheme.Interpreter.dumper}else return;if(dumper){state={a:a,f:f,c:c,s:s,x:x,stack:this.stack};dumper.dump(state)}},_execute:function(a,x,f,c,s){var ret=null;while(true){this.run_dump_hook(a,x,f,c,s);switch(x[0]){case"halt":return a;case"refer-local":var n=x[1],x=x[2];a=this.index(f,n);this.last_refer="(anon)";break;case"refer-free":var n=x[1],x=x[2];a=c[n+1];this.last_refer="(anon)";break;case"refer-global":var sym=x[1],x=x[2];if(BiwaScheme.TopEnv.hasOwnProperty(sym))var val=BiwaScheme.TopEnv[sym];else if(BiwaScheme.CoreEnv.hasOwnProperty(sym))var val=BiwaScheme.CoreEnv[sym];else throw new BiwaScheme.Error("execute: unbound symbol: "+BiwaScheme.inspect(sym));a=val;this.last_refer=sym||"(anon)";break;case"indirect":var x=x[1];a=a[0];break;case"constant":var obj=x[1],x=x[2];a=obj;this.last_refer="(anon)";break;case"close":var ox=x;var n=ox[1],body=ox[2],x=ox[3],dotpos=ox[4];a=this.closure(body,n,s,dotpos);s-=n;break;case"box":var n=x[1],x=x[2];this.index_set(s,n,[this.index(s,n)]);break;case"test":var thenc=x[1],elsec=x[2];x=a!==false?thenc:elsec;break;case"assign-global":var name=x[1],x=x[2];if(!BiwaScheme.TopEnv.hasOwnProperty(name)&&!BiwaScheme.CoreEnv.hasOwnProperty(name))throw new BiwaScheme.Error("global variable '"+name+"' is not defined");BiwaScheme.TopEnv[name]=a;a=BiwaScheme.undef;break;case"assign-local":var n=x[1],x=x[2];var box=this.index(f,n);box[0]=a;a=BiwaScheme.undef;break;case"assign-free":var n=x[1],x=x[2];var box=c[n+1];box[0]=a;a=BiwaScheme.undef;break;case"conti":var n=x[1],x=x[2];a=this.continuation(s,n);break;case"nuate":var stack=x[1],x=x[2];s=this.restore_stack(stack);break;case"frame":var ret=x[2];x=x[1];s=this.push(ret,this.push(f,this.push(c,s)));this.tco_counter[this.tco_counter.length]=0;break;case"argument":var x=x[1];s=this.push(a,s);break;case"shift":var n=x[1],x=x[2];var n_args=this.index(s,n);s=this.shift_args(n,n_args,s);break;case"tco_hinted_apply":this.tco_counter[this.tco_counter.length-1]++;x=["apply"].concat(_.rest(x));break;case"apply":var func=a;this.call_stack.push(this.last_refer);if(this.call_stack.length>this.max_trace_size){this.call_stack.shift()}var n_args=this.index(s,-1);if(func instanceof Array){a=func;x=func[0];var dotpos=func[func.length-1];if(dotpos>=0){var ls=BiwaScheme.nil;for(var i=n_args;--i>=dotpos;){ls=new BiwaScheme.Pair(this.index(s,i),ls)}if(dotpos>=n_args){for(var i=-1;i<n_args;i++){this.index_set(s,i-1,this.index(s,i))}s++;this.index_set(s,-1,this.index(s,-1)+1)}this.index_set(s,dotpos,ls)}f=s;c=a}else if(func instanceof Function){var args=[];for(var i=0;i<n_args;i++)args.push(this.index(s,i));var result=func(args,this);if(result instanceof BiwaScheme.Pause){var pause=result;pause.set_state(this,["return"],f,c,s);pause.ready();return pause}else if(result instanceof BiwaScheme.Call){var call_after=["frame",["argument",["constant",1,["argument",["constant",result.after,["apply"]]]]],["return"]];var call_proc=["constant",result.args.length,["argument",["constant",result.proc,["apply",result.args.length]]]];var push_args=_.inject(result.args,function(opc,arg){return["constant",arg,["argument",opc]]},call_proc);x=["frame",push_args,call_after]}else{a=result;x=["return"]}}else{throw new BiwaScheme.Error(BiwaScheme.inspect(func)+" is not a function")}break;case"return":var n=this.index(s,-1);var ss=s-n;x=this.index(ss,0),f=this.index(ss,1),c=this.index(ss,2),s=ss-3-1;var n_pops=1+this.tco_counter[this.tco_counter.length-1];this.call_stack.splice(-n_pops);this.tco_counter.pop();break;default:throw new BiwaScheme.Bug("unknown opecode type: "+x[0])}}return a},evaluate:function(str,after_evaluate){this.parser=new BiwaScheme.Parser(str);this.compiler=new BiwaScheme.Compiler;if(after_evaluate)this.after_evaluate=after_evaluate;if(BiwaScheme.Debug)puts("executing: "+str);this.is_top=true;this.file_stack=[];try{return this.resume(false)}catch(ex){return this.on_error(ex)}},resume:function(is_resume,a,x,f,c,s){var ret=BiwaScheme.undef;for(;;){if(is_resume){ret=this.execute(a,x,f,c,s);is_resume=false}else{if(!this.parser)break;var expr=this.parser.getObject();if(expr===BiwaScheme.Parser.EOS)break;expr=BiwaScheme.Interpreter.expand(expr);var opc=this.compiler.run(expr);ret=this.execute(expr,opc,0,[],0)}if(ret instanceof BiwaScheme.Pause){return ret}}this.after_evaluate(ret);return ret},invoke_closure:function(closure,args){args||(args=[]);var n_args=args.length;var x=["constant",n_args,["argument",["constant",closure,["apply"]]]];for(var i=0;i<n_args;i++)x=["constant",args[i],["argument",x]];return this.execute(closure,["frame",x,["halt"]],0,closure,0)},compile:function(str){var obj=BiwaScheme.Interpreter.read(str);var opc=BiwaScheme.Compiler.compile(obj);return opc}});BiwaScheme.Interpreter.read=function(str){var parser=new BiwaScheme.Parser(str);var r=parser.getObject();return r==BiwaScheme.Parser.EOS?BiwaScheme.eof:r};BiwaScheme.Interpreter.expand=function(x,flag){var expand=BiwaScheme.Interpreter.expand;flag||(flag={});var ret=null;if(x instanceof BiwaScheme.Pair){switch(x.car){case BiwaScheme.Sym("define"):var left=x.cdr.car,exp=x.cdr.cdr;ret=new BiwaScheme.Pair(BiwaScheme.Sym("define"),new BiwaScheme.Pair(left,expand(exp,flag)));break;case BiwaScheme.Sym("begin"):ret=new BiwaScheme.Pair(BiwaScheme.Sym("begin"),expand(x.cdr,flag));break;case BiwaScheme.Sym("quote"):ret=x;break;case BiwaScheme.Sym("lambda"):var vars=x.cdr.car,body=x.cdr.cdr;ret=new BiwaScheme.Pair(BiwaScheme.Sym("lambda"),new BiwaScheme.Pair(vars,expand(body,flag)));break;case BiwaScheme.Sym("if"):var testc=x.second(),thenc=x.third(),elsec=x.fourth();if(elsec==BiwaScheme.inner_of_nil){elsec=BiwaScheme.undef}ret=BiwaScheme.List(BiwaScheme.Sym("if"),expand(testc,flag),expand(thenc,flag),expand(elsec,flag));break;case BiwaScheme.Sym("set!"):var v=x.second(),x=x.third();ret=BiwaScheme.List(BiwaScheme.Sym("set!"),v,expand(x,flag));break;case BiwaScheme.Sym("call-with-current-continuation"):case BiwaScheme.Sym("call/cc"):var x=x.second();ret=BiwaScheme.List(BiwaScheme.Sym("call/cc"),expand(x,flag));break;default:var transformer=null;if(BiwaScheme.isSymbol(x.car)){if(BiwaScheme.TopEnv[x.car.name]instanceof BiwaScheme.Syntax)transformer=BiwaScheme.TopEnv[x.car.name];else if(BiwaScheme.CoreEnv[x.car.name]instanceof BiwaScheme.Syntax)transformer=BiwaScheme.CoreEnv[x.car.name]}if(transformer){flag["modified"]=true;ret=transformer.transform(x);var fl;for(;;){ret=expand(ret,fl={});if(!fl["modified"])break}}else{var expanded_car=expand(x.car,flag);var expanded_cdr;if(!(x.cdr instanceof BiwaScheme.Pair)&&x.cdr!==BiwaScheme.nil){throw new Error("proper list required for function application "+"or macro use: "+BiwaScheme.to_write(x))}expanded_cdr=BiwaScheme.array_to_list(_.map(x.cdr.to_array(),function(item){return expand(item,flag)}));ret=new BiwaScheme.Pair(expanded_car,expanded_cdr)}}}else{ret=x}return ret};BiwaScheme.check_arity=function(len,min,max){var fname=arguments.callee.caller?arguments.callee.caller.fname:"(?)";if(len<min){if(max&&max==min)throw new BiwaScheme.Error(fname+": wrong number of arguments (expected: "+min+" got: "+len+")");else throw new BiwaScheme.Error(fname+": too few arguments (at least: "+min+" got: "+len+")")}else if(max&&max<len)throw new BiwaScheme.Error(fname+": too many arguments (at most: "+max+" got: "+len+")")};BiwaScheme.define_libfunc=function(fname,min,max,func){var f=function(ar,intp){BiwaScheme.check_arity(ar.length,min,max);return func(ar,intp)};func["fname"]=fname;f["fname"]=fname;f["inspect"]=function(){return this.fname};BiwaScheme.CoreEnv[fname]=f};BiwaScheme.alias_libfunc=function(fname,aliases){if(BiwaScheme.CoreEnv[fname]){if(_.isArray(aliases)){_.map(aliases,function(a){BiwaScheme.alias_libfunc(fname,a)})}else if(_.isString(aliases)){BiwaScheme.CoreEnv[aliases]=BiwaScheme.CoreEnv[fname]}else{console.error("[BUG] bad alias for library function "+"`"+fname+"': "+aliases.toString())}}else{console.error("[BUG] library function "+"`"+fname+"'"+" does not exist, so can't alias it.")}};BiwaScheme.define_syntax=function(sname,func){var s=new BiwaScheme.Syntax(sname,func);BiwaScheme.CoreEnv[sname]=s};BiwaScheme.define_scmfunc=function(fname,min,max,str){(new Interpreter).evaluate("(define "+fname+" "+str+"\n)")};BiwaScheme.make_assert=function(check){return function(){var fname=arguments.callee.caller?arguments.callee.caller.fname:"";check.apply(this,[fname].concat(_.toArray(arguments)))}};BiwaScheme.make_simple_assert=function(type,test,_fname){return BiwaScheme.make_assert(function(fname,obj,opt){if(_fname)fname=_fname;option=opt?"("+opt+")":"";if(!test(obj)){throw new BiwaScheme.Error(fname+option+": "+type+" required, but got "+BiwaScheme.to_write(obj))}})};BiwaScheme.assert_number=BiwaScheme.make_simple_assert("number",function(obj){return typeof obj=="number"||obj instanceof BiwaScheme.Complex});BiwaScheme.assert_integer=BiwaScheme.make_simple_assert("integer",function(obj){return typeof obj=="number"&&obj%1==0});BiwaScheme.assert_real=BiwaScheme.make_simple_assert("real number",function(obj){return typeof obj=="number"});BiwaScheme.assert_between=BiwaScheme.make_assert(function(fname,obj,from,to){if(typeof obj!="number"||obj!=Math.round(obj)){throw new BiwaScheme.Error(fname+": "+"number required, but got "+BiwaScheme.to_write(obj))}if(obj<from||to<obj){throw new BiwaScheme.Error(fname+": "+"number must be between "+from+" and "+to+", but got "+BiwaScheme.to_write(obj))}});BiwaScheme.assert_string=BiwaScheme.make_simple_assert("string",_.isString);BiwaScheme.assert_char=BiwaScheme.make_simple_assert("character",BiwaScheme.isChar);BiwaScheme.assert_symbol=BiwaScheme.make_simple_assert("symbol",BiwaScheme.isSymbol);BiwaScheme.assert_port=BiwaScheme.make_simple_assert("port",BiwaScheme.isPort);BiwaScheme.assert_pair=BiwaScheme.make_simple_assert("pair",BiwaScheme.isPair);BiwaScheme.assert_list=BiwaScheme.make_simple_assert("list",BiwaScheme.isList);BiwaScheme.assert_vector=BiwaScheme.make_simple_assert("vector",BiwaScheme.isVector);BiwaScheme.assert_hashtable=BiwaScheme.make_simple_assert("hashtable",BiwaScheme.isHashtable);BiwaScheme.assert_mutable_hashtable=BiwaScheme.make_simple_assert("mutable hashtable",BiwaScheme.isMutableHashtable);BiwaScheme.assert_record=BiwaScheme.make_simple_assert("record",BiwaScheme.isRecord);BiwaScheme.assert_record_td=BiwaScheme.make_simple_assert("record type descriptor",BiwaScheme.isRecordTD);BiwaScheme.assert_record_cd=BiwaScheme.make_simple_assert("record constructor descriptor",BiwaScheme.isRecordCD);BiwaScheme.assert_enum_set=BiwaScheme.make_simple_assert("enum_set",BiwaScheme.isEnumSet);BiwaScheme.assert_function=BiwaScheme.make_simple_assert("JavaScript function",_.isFunction);BiwaScheme.assert_closure=BiwaScheme.make_simple_assert("scheme function",BiwaScheme.isClosure);BiwaScheme.assert_procedure=BiwaScheme.make_simple_assert("scheme/js function",function(obj){return BiwaScheme.isClosure(obj)||_.isFunction(obj)});BiwaScheme.assert_date=BiwaScheme.make_simple_assert("date",function(obj){return obj instanceof Date});BiwaScheme.assert=BiwaScheme.make_assert(function(fname,success,message,_fname){if(!success){throw new BiwaScheme.Error((_fname||fname)+": "+message)}});BiwaScheme.deprecate=function(title,ver,alt){if(BiwaScheme.suppress_deprecation_warning)return;var msg=title+" is deprecated and will be removed in BiwaScheme "+ver+". "+"Please use "+alt+" instead";console.warn(msg)};if(typeof BiwaScheme!="object")BiwaScheme={};with(BiwaScheme){define_syntax("cond",function(x){var clauses=x.cdr;if(!(clauses instanceof Pair)||clauses===nil){throw new Error("malformed cond: cond needs list but got "+to_write_ss(clauses))}var ret=null;_.each(clauses.to_array().reverse(),function(clause){if(!(clause instanceof Pair)){throw new Error("bad clause in cond: "+to_write_ss(clause))}if(clause.car===Sym("else")){if(ret!==null){throw new Error("'else' clause of cond followed by more clauses: "+to_write_ss(clauses))}else if(clause.cdr===nil){ret=false}else if(clause.cdr.cdr===nil){ret=clause.cdr.car}else{ret=new Pair(Sym("begin"),clause.cdr)}}else{var test=clause.car;if(clause.cdr===nil){ret=List(Sym("or"),test,ret)}else if(clause.cdr.cdr===nil){ret=List(Sym("if"),test,clause.cdr.car,ret)}else if(clause.cdr.car===Sym("=>")){var test=clause.car,expr=clause.cdr.cdr.car;var tmp_sym=BiwaScheme.gensym();ret=List(Sym("let"),List(List(tmp_sym,test)),List(Sym("if"),test,List(expr,tmp_sym),ret))}else{ret=List(Sym("if"),test,new Pair(Sym("begin"),clause.cdr),ret)}}});return ret});define_syntax("case",function(x){var tmp_sym=BiwaScheme.gensym();if(x.cdr===nil){throw new Error("case: at least one clause is required")}else if(!(x.cdr instanceof Pair)){throw new Error("case: proper list is required")}else{var key=x.cdr.car;var clauses=x.cdr.cdr;var ret=undefined;_.each(clauses.to_array().reverse(),function(clause){if(clause.car===Sym("else")){if(ret===undefined){ret=new Pair(Sym("begin"),clause.cdr)}else{throw new Error("case: 'else' clause followed by more clauses: "+to_write_ss(clauses))}}else{ret=List(Sym("if"),new Pair(Sym("or"),array_to_list(_.map(clause.car.to_array(),function(d){return List(Sym("eqv?"),tmp_sym,List(Sym("quote"),d))}))),new Pair(Sym("begin"),clause.cdr),ret)}});return new Pair(Sym("let1"),new Pair(tmp_sym,new Pair(key,new Pair(ret,nil))))}});define_syntax("and",function(x){if(x.cdr==nil)return true;var objs=x.cdr.to_array();var i=objs.length-1;var t=objs[i];for(i=i-1;i>=0;i--)t=List(Sym("if"),objs[i],t,false);return t});define_syntax("or",function(x){var objs=x.cdr.to_array();var f=false;for(var i=objs.length-1;i>=0;i--)f=List(Sym("if"),objs[i],objs[i],f);return f});define_syntax("let",function(x){var name=null;if(x.cdr.car instanceof Symbol){name=x.cdr.car;x=x.cdr}var binds=x.cdr.car,body=x.cdr.cdr;if(!(binds instanceof Pair)&&binds!=BiwaScheme.nil){throw new Error("let: need a pair for bindings: got "+to_write(binds))}var vars=nil,vals=nil;for(var p=binds;p instanceof Pair;p=p.cdr){if(!(p.car instanceof Pair)){throw new Error("let: need a pair for bindings: got "+to_write(p.car))}vars=new Pair(p.car.car,vars);vals=new Pair(p.car.cdr.car,vals)}var lambda=null;if(name){vars=array_to_list(vars.to_array().reverse());vals=array_to_list(vals.to_array().reverse());var body_lambda=new Pair(Sym("lambda"),new Pair(vars,body));var init_call=new Pair(name,vals);lambda=List(Sym("letrec"),new Pair(List(name,body_lambda),nil),init_call)}else{lambda=new Pair(new Pair(Sym("lambda"),new Pair(vars,body)),vals)}return lambda});define_syntax("let*",function(x){var binds=x.cdr.car,body=x.cdr.cdr;if(!(binds instanceof Pair))throw new Error("let*: need a pair for bindings: got "+to_write(binds));var ret=null;_.each(binds.to_array().reverse(),function(bind){ret=new Pair(Sym("let"),new Pair(new Pair(bind,nil),ret==null?body:new Pair(ret,nil)))});return ret});var expand_letrec_star=function(x){var binds=x.cdr.car,body=x.cdr.cdr;if(!(binds instanceof Pair))throw new Error("letrec*: need a pair for bindings: got "+to_write(binds));var ret=body;_.each(binds.to_array().reverse(),function(bind){ret=new Pair(new Pair(Sym("set!"),bind),ret)});var letbody=nil;_.each(binds.to_array().reverse(),function(bind){letbody=new Pair(new Pair(bind.car,new Pair(BiwaScheme.undef,nil)),letbody)});return new Pair(Sym("let"),new Pair(letbody,ret))};define_syntax("letrec",expand_letrec_star);define_syntax("letrec*",expand_letrec_star);define_syntax("let-values",function(x){var mv_bindings=x.cdr.car;var body=x.cdr.cdr;var ret=null;var let_bindings=nil;var let_star_values_bindings=nil;_.each(mv_bindings.to_array().reverse(),function(item){var init=item.cdr.car;var tmpsym=BiwaScheme.gensym();var binding=new Pair(tmpsym,new Pair(new Pair(Sym("lambda"),new Pair(nil,new Pair(init,nil))),nil));let_bindings=new Pair(binding,let_bindings);var formals=item.car;let_star_values_bindings=new Pair(new Pair(formals,new Pair(new Pair(tmpsym,nil),nil)),let_star_values_bindings)});var let_star_values=new Pair(Sym("let*-values"),new Pair(let_star_values_bindings,body));ret=new Pair(Sym("let"),new Pair(let_bindings,new Pair(let_star_values,nil)));return ret});define_syntax("let*-values",function(x){var mv_bindings=x.cdr.car;var body=x.cdr.cdr;var ret=null;_.each(mv_bindings.to_array().reverse(),function(item){var formals=item.car,init=item.cdr.car;ret=new Pair(Sym("call-with-values"),new Pair(new Pair(Sym("lambda"),new Pair(nil,new Pair(init,nil))),new Pair(new Pair(Sym("lambda"),new Pair(formals,ret==null?body:new Pair(ret,nil))),nil)))});return ret});BiwaScheme.eq=function(a,b){return a===b};BiwaScheme.eqv=function(a,b){return a==b&&typeof a==typeof b};define_libfunc("eqv?",2,2,function(ar){return BiwaScheme.eqv(ar[0],ar[1])});define_libfunc("eq?",2,2,function(ar){return BiwaScheme.eq(ar[0],ar[1])});define_libfunc("equal?",2,2,function(ar){return to_write(ar[0])==to_write(ar[1])});define_libfunc("procedure?",1,1,function(ar){return ar[0]instanceof Array&&ar[0].closure_p===true||typeof ar[0]=="function"});define_libfunc("number?",1,1,function(ar){return typeof ar[0]=="number"||ar[0]instanceof Complex||ar[0]instanceof Rational});define_libfunc("complex?",1,1,function(ar){return ar[0]instanceof Complex});define_libfunc("real?",1,1,function(ar){return typeof ar[0]=="number"});define_libfunc("rational?",1,1,function(ar){return ar[0]instanceof Rational});define_libfunc("integer?",1,1,function(ar){return typeof ar[0]=="number"&&ar[0]==Math.round(ar[0])&&ar[0]!=Infinity&&ar[0]!=-Infinity});define_libfunc("=",2,null,function(ar){var v=ar[0];assert_number(ar[0]);for(var i=1;i<ar.length;i++){assert_number(ar[i]);if(ar[i]!=v)return false}return true});define_libfunc("<",2,null,function(ar){assert_number(ar[0]);for(var i=1;i<ar.length;i++){assert_number(ar[i]);if(!(ar[i-1]<ar[i]))return false}return true});define_libfunc(">",2,null,function(ar){assert_number(ar[0]);for(var i=1;i<ar.length;i++){assert_number(ar[i]);if(!(ar[i-1]>ar[i]))return false}return true});define_libfunc("<=",2,null,function(ar){assert_number(ar[0]);for(var i=1;i<ar.length;i++){assert_number(ar[i]);if(!(ar[i-1]<=ar[i]))return false}return true});define_libfunc(">=",2,null,function(ar){assert_number(ar[0]);for(var i=1;i<ar.length;i++){assert_number(ar[i]);if(!(ar[i-1]>=ar[i]))return false}return true});define_libfunc("zero?",1,1,function(ar){assert_number(ar[0]);return ar[0]===0});define_libfunc("positive?",1,1,function(ar){assert_number(ar[0]);return ar[0]>0});define_libfunc("negative?",1,1,function(ar){assert_number(ar[0]);return ar[0]<0});define_libfunc("odd?",1,1,function(ar){assert_number(ar[0]);return ar[0]%2==1||ar[0]%2==-1});define_libfunc("even?",1,1,function(ar){assert_number(ar[0]);return ar[0]%2==0});define_libfunc("finite?",1,1,function(ar){assert_number(ar[0]);return ar[0]!=Infinity&&ar[0]!=-Infinity&&!isNaN(ar[0])});define_libfunc("infinite?",1,1,function(ar){assert_number(ar[0]);return ar[0]==Infinity||ar[0]==-Infinity});define_libfunc("nan?",1,1,function(ar){assert_number(ar[0]);return isNaN(ar[0])});define_libfunc("max",2,null,function(ar){for(var i=0;i<ar.length;i++)assert_number(ar[i]);return Math.max.apply(null,ar)});define_libfunc("min",2,null,function(ar){for(var i=0;i<ar.length;i++)assert_number(ar[i]);return Math.min.apply(null,ar)});define_libfunc("+",0,null,function(ar){var n=0;for(var i=0;i<ar.length;i++){assert_number(ar[i]);n+=ar[i]}return n});define_libfunc("*",0,null,function(ar){var n=1;for(var i=0;i<ar.length;i++){assert_number(ar[i]);n*=ar[i]}return n});define_libfunc("-",1,null,function(ar){var len=ar.length;assert_number(ar[0]);if(len==1)return-ar[0];else{var n=ar[0];for(var i=1;i<len;i++){assert_number(ar[i]);n-=ar[i]}return n}});define_libfunc("/",1,null,function(ar){var len=ar.length;assert_number(ar[0]);if(len==1)return 1/ar[0];else{var n=ar[0];for(var i=1;i<len;i++){assert_number(ar[i]);n/=ar[i]}return n}});define_libfunc("abs",1,1,function(ar){assert_number(ar[0]);return Math.abs(ar[0])});var div=function(n,m){return Math.floor(n/m)};var mod=function(n,m){return n-Math.floor(n/m)*m};var div0=function(n,m){return n>0?Math.floor(n/m):Math.ceil(n/m)};var mod0=function(n,m){return n>0?n-Math.floor(n/m)*m:n-Math.ceil(n/m)*m};define_libfunc("div0-and-mod0",2,2,function(ar){assert_number(ar[0]);assert_number(ar[1]);return new Values([div(ar[0],ar[1]),mod(ar[0],ar[1])])});define_libfunc("div",2,2,function(ar){assert_number(ar[0]);assert_number(ar[1]);return div(ar[0],ar[1])});define_libfunc("mod",2,2,function(ar){assert_number(ar[0]);assert_number(ar[1]);return mod(ar[0],ar[1])});define_libfunc("div0-and-mod0",2,2,function(ar){assert_number(ar[0]);assert_number(ar[1]);return new Values([div0(ar[0],ar[1]),mod0(ar[0],ar[1])])});define_libfunc("div0",2,2,function(ar){assert_number(ar[0]);assert_number(ar[1]);return div0(ar[0],ar[1])});define_libfunc("mod0",2,2,function(ar){assert_number(ar[0]);assert_number(ar[1]);return mod0(ar[0],ar[1])});define_libfunc("numerator",1,1,function(ar){assert_number(ar[0]);if(ar[0]instanceof Rational)return ar[0].numerator;else throw new Bug("todo")});define_libfunc("denominator",1,1,function(ar){assert_number(ar[0]);if(ar[0]instanceof Rational)return ar[0].denominator;else throw new Bug("todo")});define_libfunc("floor",1,1,function(ar){assert_number(ar[0]);return Math.floor(ar[0])});define_libfunc("ceiling",1,1,function(ar){assert_number(ar[0]);return Math.ceil(ar[0])});define_libfunc("truncate",1,1,function(ar){assert_number(ar[0]);return ar[0]<0?Math.ceil(ar[0]):Math.floor(ar[0])});define_libfunc("round",1,1,function(ar){assert_number(ar[0]);return Math.round(ar[0])});define_libfunc("exp",1,1,function(ar){assert_number(ar[0]);return Math.exp(ar[0])});define_libfunc("log",1,2,function(ar){var num=ar[0],base=ar[1];assert_number(num);if(base){assert_number(base);return Math.log(num)/Math.log(b)}else return Math.log(num)});define_libfunc("sin",1,1,function(ar){assert_number(ar[0]);return Math.sin(ar[0])});define_libfunc("cos",1,1,function(ar){assert_number(ar[0]);return Math.cos(ar[0])});define_libfunc("tan",1,1,function(ar){assert_number(ar[0]);return Math.tan(ar[0])});define_libfunc("asin",1,1,function(ar){assert_number(ar[0]);return Math.asin(ar[0])});define_libfunc("acos",1,1,function(ar){assert_number(ar[0]);return Math.acos(ar[0])});define_libfunc("atan",1,2,function(ar){assert_number(ar[0]);if(ar.length==2){assert_number(ar[1]);return Math.atan2(ar[0],ar[1])}else return Math.atan(ar[0])});define_libfunc("sqrt",1,1,function(ar){assert_number(ar[0]);return Math.sqrt(ar[0])});define_libfunc("exact-integer-sqrt",1,1,function(ar){assert_number(ar[0]);var sqrt_f=Math.sqrt(ar[0]);var sqrt_i=sqrt_f-sqrt_f%1;var rest=ar[0]-sqrt_i*sqrt_i;return new Values([sqrt_i,rest]);

});define_libfunc("expt",2,2,function(ar){assert_number(ar[0]);assert_number(ar[1]);return Math.pow(ar[0],ar[1])});define_libfunc("make-rectangular",2,2,function(ar){assert_number(ar[0]);assert_number(ar[1]);return new Complex(ar[0],ar[1])});define_libfunc("make-polar",2,2,function(ar){assert_number(ar[0]);assert_number(ar[1]);return Complex.from_polar(ar[0],ar[1])});define_libfunc("real-part",1,1,function(ar){assert_number(ar[0]);return Complex.assure(ar[0]).real});define_libfunc("imag-part",1,1,function(ar){assert_number(ar[0]);return Complex.assure(ar[0]).imag});define_libfunc("magnitude",1,1,function(ar){assert_number(ar[0]);return Complex.assure(ar[0]).magnitude()});define_libfunc("angle",1,1,function(ar){assert_number(ar[0]);return Complex.assure(ar[0]).angle()});define_libfunc("number->string",1,3,function(ar){var z=ar[0],radix=ar[1],precision=ar[2];if(precision)throw new Bug("number->string: precision is not yet implemented");radix=radix||10;return z.toString(radix)});define_libfunc("string->number",1,3,function(ar){var s=ar[0],radix=ar[1]||10;switch(s){case"+inf.0":return Infinity;case"-inf.0":return-Infinity;case"+nan.0":return NaN;default:if(s.match(/[eE.]/))return parseFloat(s);else return parseInt(s,radix)}});define_libfunc("not",1,1,function(ar){return ar[0]===false?true:false});define_libfunc("boolean?",1,1,function(ar){return ar[0]===false||ar[0]===true?true:false});define_libfunc("boolean=?",2,null,function(ar){var len=ar.length;for(var i=1;i<len;i++){if(ar[i]!=ar[0])return false}return true});define_libfunc("pair?",1,1,function(ar){return ar[0]instanceof Pair?true:false});define_libfunc("cons",2,2,function(ar){return new Pair(ar[0],ar[1])});define_libfunc("car",1,1,function(ar){if(!(ar[0]instanceof Pair))throw new Error("Attempt to apply car on "+ar[0]);return ar[0].car});define_libfunc("cdr",1,1,function(ar){if(!(ar[0]instanceof Pair))throw new Error("Attempt to apply cdr on "+ar[0]);return ar[0].cdr});define_libfunc("set-car!",2,2,function(ar){if(!(ar[0]instanceof Pair))throw new Error("Attempt to apply set-car! on "+ar[0]);ar[0].car=ar[1];return BiwaScheme.undef});define_libfunc("set-cdr!",2,2,function(ar){if(!(ar[0]instanceof Pair))throw new Error("Attempt to apply set-cdr! on "+ar[0]);ar[0].cdr=ar[1];return BiwaScheme.undef});(function(){var get=function(funcname,spec,obj){var ret=obj;_.each(spec,function(is_cdr){if(ret instanceof Pair){ret=is_cdr?ret.cdr:ret.car}else{throw new Error(funcname+": attempt to get "+(is_cdr?"cdr":"car")+" of "+ret)}});return ret};define_libfunc("caar",1,1,function(ar){return get("caar",[0,0],ar[0])});define_libfunc("cadr",1,1,function(ar){return get("cadr",[1,0],ar[0])});define_libfunc("cdar",1,1,function(ar){return get("cadr",[0,1],ar[0])});define_libfunc("cddr",1,1,function(ar){return get("cadr",[1,1],ar[0])});define_libfunc("caaar",1,1,function(ar){return get("caaar",[0,0,0],ar[0])});define_libfunc("caadr",1,1,function(ar){return get("caadr",[1,0,0],ar[0])});define_libfunc("cadar",1,1,function(ar){return get("cadar",[0,1,0],ar[0])});define_libfunc("caddr",1,1,function(ar){return get("caddr",[1,1,0],ar[0])});define_libfunc("cdaar",1,1,function(ar){return get("cdaar",[0,0,1],ar[0])});define_libfunc("cdadr",1,1,function(ar){return get("cdadr",[1,0,1],ar[0])});define_libfunc("cddar",1,1,function(ar){return get("cddar",[0,1,1],ar[0])});define_libfunc("cdddr",1,1,function(ar){return get("cdddr",[1,1,1],ar[0])});define_libfunc("caaaar",1,1,function(ar){return get("caaaar",[0,0,0,0],ar[0])});define_libfunc("caaadr",1,1,function(ar){return get("caaadr",[1,0,0,0],ar[0])});define_libfunc("caadar",1,1,function(ar){return get("caadar",[0,1,0,0],ar[0])});define_libfunc("caaddr",1,1,function(ar){return get("caaddr",[1,1,0,0],ar[0])});define_libfunc("cadaar",1,1,function(ar){return get("cadaar",[0,0,1,0],ar[0])});define_libfunc("cadadr",1,1,function(ar){return get("cadadr",[1,0,1,0],ar[0])});define_libfunc("caddar",1,1,function(ar){return get("caddar",[0,1,1,0],ar[0])});define_libfunc("cadddr",1,1,function(ar){return get("cadddr",[1,1,1,0],ar[0])});define_libfunc("cdaaar",1,1,function(ar){return get("cdaaar",[0,0,0,1],ar[0])});define_libfunc("cdaadr",1,1,function(ar){return get("cdaadr",[1,0,0,1],ar[0])});define_libfunc("cdadar",1,1,function(ar){return get("cdadar",[0,1,0,1],ar[0])});define_libfunc("cdaddr",1,1,function(ar){return get("cdaddr",[1,1,0,1],ar[0])});define_libfunc("cddaar",1,1,function(ar){return get("cddaar",[0,0,1,1],ar[0])});define_libfunc("cddadr",1,1,function(ar){return get("cddadr",[1,0,1,1],ar[0])});define_libfunc("cdddar",1,1,function(ar){return get("cdddar",[0,1,1,1],ar[0])});define_libfunc("cddddr",1,1,function(ar){return get("cddddr",[1,1,1,1],ar[0])})})();define_libfunc("null?",1,1,function(ar){return ar[0]===nil});define_libfunc("list?",1,1,function(ar){return isList(ar[0])});define_libfunc("list",0,null,function(ar){var l=nil;for(var i=ar.length-1;i>=0;i--)l=new Pair(ar[i],l);return l});define_libfunc("length",1,1,function(ar){assert_list(ar[0]);var n=0;for(var o=ar[0];o!=nil;o=o.cdr)n++;return n});define_libfunc("append",2,null,function(ar){var k=ar.length;var ret=ar[--k];while(k--){_.each(ar[k].to_array().reverse(),function(item){ret=new Pair(item,ret)})}return ret});define_libfunc("reverse",1,1,function(ar){if(ar[0]==nil)return nil;assert_pair(ar[0]);var l=nil;for(var o=ar[0];o!=nil;o=o.cdr)l=new Pair(o.car,l);return l});define_libfunc("list-tail",2,2,function(ar){assert_pair(ar[0]);assert_integer(ar[1]);if(ar[1]<0)throw new Error("list-tail: index out of range ("+ar[1]+")");var o=ar[0];for(var i=0;i<ar[1];i++){if(!(o instanceof Pair))throw new Error("list-tail: the list is shorter than "+ar[1]);o=o.cdr}return o});define_libfunc("list-ref",2,2,function(ar){assert_pair(ar[0]);assert_integer(ar[1]);if(ar[1]<0)throw new Error("list-tail: index out of range ("+ar[1]+")");var o=ar[0];for(var i=0;i<ar[1];i++){if(!(o instanceof Pair))throw new Error("list-ref: the list is shorter than "+ar[1]);o=o.cdr}return o.car});define_libfunc("map",2,null,function(ar){var proc=ar.shift(),lists=ar;_.each(lists,assert_list);var a=[];return Call.multi_foreach(lists,{call:function(xs){return new Call(proc,_.map(xs,function(x){return x.car}))},result:function(res){a.push(res)},finish:function(){return array_to_list(a)}})});define_libfunc("for-each",2,null,function(ar){var proc=ar.shift(),lists=ar;_.each(lists,assert_list);return Call.multi_foreach(lists,{call:function(xs){return new Call(proc,_.map(xs,function(x){return x.car}))},finish:function(){return BiwaScheme.undef}})});define_libfunc("symbol?",1,1,function(ar){return ar[0]instanceof Symbol?true:false});define_libfunc("symbol->string",1,1,function(ar){assert_symbol(ar[0]);return ar[0].name});define_libfunc("symbol=?",2,null,function(ar){assert_symbol(ar[0]);for(var i=1;i<ar.length;i++){assert_symbol(ar[i]);if(ar[i]!=ar[0])return false}return true});define_libfunc("string->symbol",1,1,function(ar){assert_string(ar[0]);return Sym(ar[0])});define_libfunc("char?",1,1,function(ar){return ar[0]instanceof Char});define_libfunc("char->integer",1,1,function(ar){assert_char(ar[0]);return ar[0].value.charCodeAt(0)});define_libfunc("integer->char",1,1,function(ar){assert_integer(ar[0]);return Char.get(String.fromCharCode(ar[0]))});var make_char_compare_func=function(test){return function(ar){assert_char(ar[0]);for(var i=1;i<ar.length;i++){assert_char(ar[i]);if(!test(ar[i-1].value,ar[i].value))return false}return true}};define_libfunc("char=?",2,null,make_char_compare_func(function(a,b){return a==b}));define_libfunc("char<?",2,null,make_char_compare_func(function(a,b){return a<b}));define_libfunc("char>?",2,null,make_char_compare_func(function(a,b){return a>b}));define_libfunc("char<=?",2,null,make_char_compare_func(function(a,b){return a<=b}));define_libfunc("char>=?",2,null,make_char_compare_func(function(a,b){return a>=b}));define_libfunc("string?",1,1,function(ar){return typeof ar[0]=="string"});define_libfunc("make-string",1,2,function(ar){assert_integer(ar[0]);var c=" ";if(ar[1]){assert_char(ar[1]);c=ar[1].value}var out="";_.times(ar[0],function(){out+=c});return out});define_libfunc("string",1,null,function(ar){for(var i=0;i<ar.length;i++)assert_char(ar[i]);return _.map(ar,function(c){return c.value}).join("")});define_libfunc("string-length",1,1,function(ar){assert_string(ar[0]);return ar[0].length});define_libfunc("string-ref",2,2,function(ar){assert_string(ar[0]);assert_between(ar[1],0,ar[0].length-1);return Char.get(ar[0].charAt([ar[1]]))});define_libfunc("string=?",2,null,function(ar){assert_string(ar[0]);for(var i=1;i<ar.length;i++){assert_string(ar[i]);if(ar[0]!=ar[i])return false}return true});define_libfunc("string<?",2,null,function(ar){assert_string(ar[0]);for(var i=1;i<ar.length;i++){assert_string(ar[i]);if(!(ar[i-1]<ar[i]))return false}return true});define_libfunc("string>?",2,null,function(ar){assert_string(ar[0]);for(var i=1;i<ar.length;i++){assert_string(ar[i]);if(!(ar[i-1]>ar[i]))return false}return true});define_libfunc("string<=?",2,null,function(ar){assert_string(ar[0]);for(var i=1;i<ar.length;i++){assert_string(ar[i]);if(!(ar[i-1]<=ar[i]))return false}return true});define_libfunc("string>=?",2,null,function(ar){assert_string(ar[0]);for(var i=1;i<ar.length;i++){assert_string(ar[i]);if(!(ar[i-1]>=ar[i]))return false}return true});define_libfunc("substring",3,3,function(ar){assert_string(ar[0]);assert_integer(ar[1]);assert_integer(ar[2]);if(ar[1]<0)throw new Error("substring: start too small: "+ar[1]);if(ar[2]<0)throw new Error("substring: end too small: "+ar[2]);if(ar[0].length+1<=ar[1])throw new Error("substring: start too big: "+ar[1]);if(ar[0].length+1<=ar[2])throw new Error("substring: end too big: "+ar[2]);if(!(ar[1]<=ar[2]))throw new Error("substring: not start <= end: "+ar[1]+", "+ar[2]);return ar[0].substring(ar[1],ar[2])});define_libfunc("string-append",0,null,function(ar){for(var i=0;i<ar.length;i++)assert_string(ar[i]);return ar.join("")});define_libfunc("string->list",1,1,function(ar){assert_string(ar[0]);return array_to_list(_.map(ar[0].split(""),function(s){return Char.get(s[0])}))});define_libfunc("list->string",1,1,function(ar){assert_list(ar[0]);return _.map(ar[0].to_array(),function(c){return c.value}).join("")});define_libfunc("string-for-each",2,null,function(ar){var proc=ar.shift(),strs=ar;_.each(strs,assert_string);return Call.multi_foreach(strs,{call:function(chars){return new Call(proc,chars)},finish:function(){return BiwaScheme.undef}})});define_libfunc("string-copy",1,1,function(ar){assert_string(ar[0]);return ar[0]});define_libfunc("vector?",1,1,function(ar){return ar[0]instanceof Array&&ar[0].closure_p!==true});define_libfunc("make-vector",1,2,function(ar){assert_integer(ar[0]);var vec=new Array(ar[0]);if(ar.length==2){for(var i=0;i<ar[0];i++)vec[i]=ar[1]}return vec});define_libfunc("vector",1,null,function(ar){return ar});define_libfunc("vector-length",1,1,function(ar){assert_vector(ar[0]);return ar[0].length});define_libfunc("vector-ref",2,2,function(ar){assert_vector(ar[0]);assert_integer(ar[1]);assert_between(ar[1],0,ar[0].length-1);return ar[0][ar[1]]});define_libfunc("vector-set!",3,3,function(ar){assert_vector(ar[0]);assert_integer(ar[1]);ar[0][ar[1]]=ar[2];return BiwaScheme.undef});define_libfunc("vector->list",1,1,function(ar){assert_vector(ar[0]);return array_to_list(ar[0])});define_libfunc("list->vector",1,1,function(ar){assert_list(ar[0]);return ar[0].to_array()});define_libfunc("vector-fill!",2,2,function(ar){assert_vector(ar[0]);var vec=ar[0],obj=ar[1];for(var i=0;i<vec.length;i++)vec[i]=obj;return vec});define_libfunc("vector-map",2,null,function(ar){var proc=ar.shift(),vecs=ar;_.each(vecs,assert_vector);var a=[];return Call.multi_foreach(vecs,{call:function(objs){return new Call(proc,objs)},result:function(res){a.push(res)},finish:function(){return a}})});define_libfunc("vector-for-each",2,null,function(ar){var proc=ar.shift(),vecs=ar;_.each(vecs,assert_vector);return Call.multi_foreach(vecs,{call:function(objs){return new Call(proc,objs)},finish:function(){return BiwaScheme.undef}})});define_libfunc("apply",2,null,function(ar){var proc=ar.shift(),rest_args=ar.pop(),args=ar;args=args.concat(rest_args.to_array());return new Call(proc,args)});define_syntax("call-with-current-continuation",function(x){return new Pair(Sym("call/cc"),x.cdr)});define_libfunc("values",0,null,function(ar){if(ar.length==1)return ar[0];else return new Values(ar)});define_libfunc("call-with-values",2,2,function(ar){var producer=ar[0],consumer=ar[1];assert_procedure(producer);assert_procedure(consumer);return new Call(producer,[],function(ar){var result=ar[0];if(result instanceof Values){return new Call(consumer,result.content)}else{return new Call(consumer,[result])}})});var expand_qq=function(f,lv){if(f instanceof Symbol||f===nil){return List(Sym("quote"),f)}else if(f instanceof Pair){var car=f.car;if(car instanceof Pair&&car.car===Sym("unquote-splicing")){var lv=lv-1;if(lv==0)return List(Sym("append"),f.car.cdr.car,expand_qq(f.cdr,lv+1));else return List(Sym("cons"),List(Sym("list"),Sym("unquote-splicing"),expand_qq(f.car.cdr.car,lv)),expand_qq(f.cdr,lv+1))}else if(car===Sym("unquote")){var lv=lv-1;if(lv==0)return f.cdr.car;else return List(Sym("list"),List(Sym("quote"),Sym("unquote")),expand_qq(f.cdr.car,lv))}else if(car===Sym("quasiquote"))return List(Sym("list"),Sym("quasiquote"),expand_qq(f.cdr.car,lv+1));else return List(Sym("cons"),expand_qq(f.car,lv),expand_qq(f.cdr,lv))}else if(f instanceof Array){throw new Bug("vector quasiquotation is not implemented yet")}else return f};define_syntax("quasiquote",function(x){return expand_qq(x.cdr.car,1)});define_syntax("unquote",function(x){throw new Error("unquote(,) must be inside quasiquote(`)")});define_syntax("unquote-splicing",function(x){throw new Error("unquote-splicing(,@) must be inside quasiquote(`)")});define_libfunc("string-upcase",1,1,function(ar){assert_string(ar[0]);return ar[0].toUpperCase()});define_libfunc("string-downcase",1,1,function(ar){assert_string(ar[0]);return ar[0].toLowerCase()});BiwaScheme.make_string_ci_function=function(compare){return function(ar){assert_string(ar[0]);var str=ar[0].toUpperCase();for(var i=1;i<ar.length;i++){assert_string(ar[i]);if(!compare(str,ar[i].toUpperCase()))return false}return true}};define_libfunc("string-ci=?",2,null,make_string_ci_function(function(a,b){return a==b}));define_libfunc("string-ci<?",2,null,make_string_ci_function(function(a,b){return a<b}));define_libfunc("string-ci>?",2,null,make_string_ci_function(function(a,b){return a>b}));define_libfunc("string-ci<=?",2,null,make_string_ci_function(function(a,b){return a<=b}));define_libfunc("string-ci>=?",2,null,make_string_ci_function(function(a,b){return a>=b}));define_libfunc("find",2,2,function(ar){var proc=ar[0],ls=ar[1];assert_list(ls);return Call.foreach(ls,{call:function(x){return new Call(proc,[x.car])},result:function(res,x){if(res)return x.car},finish:function(){return false}})});define_libfunc("for-all",2,null,function(ar){var proc=ar.shift();var lists=ar;_.each(lists,assert_list);var last=true;return Call.multi_foreach(lists,{call:function(pairs){return new Call(proc,_.map(pairs,function(x){return x.car}))},result:function(res,pairs){if(res===false)return false;last=res},finish:function(){return last}})});define_libfunc("exists",2,null,function(ar){var proc=ar.shift();var lists=ar;_.each(lists,assert_list);return Call.multi_foreach(lists,{call:function(pairs){return new Call(proc,_.map(pairs,function(x){return x.car}))},result:function(res,pairs){if(res!==false)return res},finish:function(){return false}})});define_libfunc("filter",2,2,function(ar){var proc=ar[0],ls=ar[1];assert_list(ls);var a=[];return Call.foreach(ls,{call:function(x){return new Call(proc,[x.car])},result:function(res,x){if(res)a.push(x.car)},finish:function(){return array_to_list(a)}})});define_libfunc("partition",2,2,function(ar){var proc=ar[0],ls=ar[1];assert_list(ls);var t=[],f=[];return Call.foreach(ls,{call:function(x){return new Call(proc,[x.car])},result:function(res,x){if(res)t.push(x.car);else f.push(x.car)},finish:function(){return new Values([array_to_list(t),array_to_list(f)])}})});define_libfunc("fold-left",3,null,function(ar){var proc=ar.shift(),accum=ar.shift(),lists=ar;_.each(lists,assert_list);return Call.multi_foreach(lists,{call:function(pairs){var args=_.map(pairs,function(x){return x.car});args.unshift(accum);return new Call(proc,args)},result:function(res,pairs){accum=res},finish:function(){return accum}})});define_libfunc("fold-right",3,null,function(ar){var proc=ar.shift(),accum=ar.shift();var lists=_.map(ar,function(ls){assert_list(ls);return array_to_list(ls.to_array().reverse())});return Call.multi_foreach(lists,{call:function(pairs){var args=_.map(pairs,function(x){return x.car});args.push(accum);return new Call(proc,args)},result:function(res,pairs){accum=res},finish:function(){return accum}})});define_libfunc("remp",2,2,function(ar){var proc=ar[0],ls=ar[1];assert_list(ls);var ret=[];return Call.foreach(ls,{call:function(x){return new Call(proc,[x.car])},result:function(res,x){if(!res)ret.push(x.car)},finish:function(){return array_to_list(ret)}})});var make_remover=function(key){return function(ar){var obj=ar[0],ls=ar[1];assert_list(ls);var ret=[];return Call.foreach(ls,{call:function(x){return new Call(TopEnv[key]||CoreEnv[key],[obj,x.car])},result:function(res,x){if(!res)ret.push(x.car)},finish:function(){return array_to_list(ret)}})}};define_libfunc("remove",2,2,make_remover("equal?"));define_libfunc("remv",2,2,make_remover("eqv?"));define_libfunc("remq",2,2,make_remover("eq?"));define_libfunc("memp",2,2,function(ar){var proc=ar[0],ls=ar[1];assert_list(ls);var ret=[];return Call.foreach(ls,{call:function(x){return new Call(proc,[x.car])},result:function(res,x){if(res)return x},finish:function(){return false}})});var make_finder=function(key){return function(ar){var obj=ar[0],ls=ar[1];assert_list(ls);var ret=[];return Call.foreach(ls,{call:function(x){return new Call(TopEnv[key]||CoreEnv[key],[obj,x.car])},result:function(res,x){if(res)return x},finish:function(){return false}})}};define_libfunc("member",2,2,make_finder("equal?"));define_libfunc("memv",2,2,make_finder("eqv?"));define_libfunc("memq",2,2,make_finder("eq?"));define_libfunc("assp",2,2,function(ar){var proc=ar[0],als=ar[1];assert_list(als);var ret=[];return Call.foreach(als,{call:function(x){if(x.car.car)return new Call(proc,[x.car.car]);else throw new Error("ass*: pair required but got "+to_write(x.car))},result:function(res,x){if(res)return x.car},finish:function(){return false}})});var make_assoc=function(func_name,eq_func_name){return function(ar){var obj=ar[0],list=ar[1];assert_list(list);var ret=[];return Call.foreach(list,{call:function(ls){if(!BiwaScheme.isPair(ls.car))throw new Error(func_name+": pair required but got "+to_write(ls.car));var equality=TopEnv[eq_func_name]||CoreEnv[eq_func_name];return new Call(equality,[obj,ls.car.car])},result:function(was_equal,ls){if(was_equal)return ls.car},finish:function(){return false}})}};define_libfunc("assoc",2,2,make_assoc("assoc","equal?"));define_libfunc("assv",2,2,make_assoc("assv","eqv?"));define_libfunc("assq",2,2,make_assoc("assq","eq?"));define_libfunc("cons*",1,null,function(ar){if(ar.length==1)return ar[0];else{var ret=null;_.each(ar.reverse(),function(x){if(ret){ret=new Pair(x,ret)}else ret=x});return ret}});(function(){var compareFn=function(a,b){if(typeof a!==typeof b){return compareFn(typeof a,typeof b)}return a>b?1:a<b?-1:0};define_libfunc("list-sort",1,2,function(ar){if(ar[1]){throw new Bug("list-sort: cannot take compare proc now")}assert_list(ar[0]);return array_to_list(ar[0].to_array().sort(compareFn))});define_libfunc("vector-sort",1,2,function(ar){if(ar[1]){throw new Bug("vector-sort: cannot take compare proc now")}assert_vector(ar[0]);return _.clone(ar[0]).sort(compareFn)});define_libfunc("vector-sort!",1,2,function(ar){if(ar[1]){throw new Bug("vector-sort!: cannot take compare proc now")}assert_vector(ar[0]);ar[0].sort(compareFn);return BiwaScheme.undef})})();define_syntax("when",function(x){var test=x.cdr.car,body=x.cdr.cdr;return new Pair(Sym("if"),new Pair(test,new Pair(new Pair(Sym("begin"),body),new Pair(BiwaScheme.undef,nil))))});define_syntax("unless",function(x){var test=x.cdr.car,body=x.cdr.cdr;return new Pair(Sym("if"),new Pair(new Pair(Sym("not"),new Pair(test,nil)),new Pair(new Pair(Sym("begin"),body),new Pair(BiwaScheme.undef,nil))))});define_syntax("do",function(x){if(!BiwaScheme.isPair(x.cdr))throw new Error("do: no variables of do");var varsc=x.cdr.car;if(!BiwaScheme.isPair(varsc))throw new Error("do: variables must be given as a list");if(!BiwaScheme.isPair(x.cdr.cdr))throw new Error("do: no resulting form of do");var resultc=x.cdr.cdr.car;var bodyc=x.cdr.cdr.cdr;var loop=BiwaScheme.gensym();var init_vars=array_to_list(varsc.map(function(var_def){var a=var_def.to_array();return List(a[0],a[1])}));var test=resultc.car;var result_exprs=new Pair(Sym("begin"),resultc.cdr);var next_loop=new Pair(loop,array_to_list(varsc.map(function(var_def){var a=var_def.to_array();return a[2]||a[0]})));var body_exprs=new Pair(Sym("begin"),bodyc).concat(List(next_loop));return List(Sym("let"),loop,init_vars,List(Sym("if"),test,result_exprs,body_exprs))});define_syntax("case-lambda",function(x){});define_syntax("define-record-type",function(x){var name_spec=x.cdr.car;var record_clauses=x.cdr.cdr;if(BiwaScheme.isSymbol(name_spec)){var record_name=name_spec;var constructor_name=Sym("make-"+name_spec.name);var predicate_name=Sym(name_spec.name+"?")}else{assert_list(name_spec);var record_name=name_spec.car;var constructor_name=name_spec.cdr.car;var predicate_name=name_spec.cdr.cdr.car;assert_symbol(record_name);assert_symbol(constructor_name);assert_symbol(predicate_name)}var sealed=false;var opaque=false;var nongenerative=false;var uid=false;var parent_name;var parent_rtd=false;var parent_cd=false;var protocol=false;var fields=[];_.each(record_clauses.to_array(),function(clause){switch(clause.car){case Sym("fields"):fields=_.map(clause.cdr.to_array(),function(field_spec,idx){if(BiwaScheme.isSymbol(field_spec)){return{name:field_spec,idx:idx,mutable:false,accessor_name:null,mutator_name:null}}else{assert_list(field_spec);assert_symbol(field_spec.car);switch(field_spec.car){case Sym("immutable"):var field_name=field_spec.cdr.car;assert_symbol(field_name);if(BiwaScheme.isNil(field_spec.cdr.cdr))return{name:field_name,idx:idx,mutable:false};else return{name:field_name,idx:idx,mutable:false,accessor_name:field_spec.cdr.cdr.car};break;case Sym("mutable"):var field_name=field_spec.cdr.car;assert_symbol(field_name);if(BiwaScheme.isNil(field_spec.cdr.cdr))return{name:field_name,idx:idx,mutable:true};else return{name:field_name,idx:idx,mutable:true,accessor_name:field_spec.cdr.cdr.car,mutator_name:field_spec.cdr.cdr.cdr.car};break;default:throw new Error("define-record-type: field definition "+"must start with `immutable' or `mutable' "+"but got "+BiwaScheme.inspect(field_spec.car))}}});break;case Sym("parent"):parent_name=clause.cdr.car;assert_symbol(parent_name);break;case Sym("protocol"):protocol=clause.cdr.car;break;case Sym("sealed"):sealed=!!clause.cdr.car;break;case Sym("opaque"):opaque=!!clause.cdr.car;break;case Sym("nongenerative"):nongenerative=true;uid=clause.cdr.car;break;case Sym("parent-rtd"):parent_rtd=clause.cdr.car;parent_cd=clause.cdr.cdr.car;break;default:throw new BiwaScheme.Error("define-record-type: unknown clause `"+BiwaScheme.to_write(clause.car)+"'")}});if(parent_name){parent_rtd=[Sym("record-type-descriptor"),parent_name];parent_cd=[Sym("record-constructor-descriptor"),parent_name]}var rtd=[Sym("record-type-descriptor"),record_name];var cd=[Sym("record-constructor-descriptor"),record_name];var rtd_fields=_.map(fields,function(field){return List(Sym(field.mutable?"mutable":"immutable"),field.name)});rtd_fields.is_vector=true;var rtd_def=[Sym("make-record-type-descriptor"),[Sym("quote"),record_name],parent_rtd,uid,sealed,opaque,rtd_fields];var cd_def=[Sym("make-record-constructor-descriptor"),Sym("__rtd"),parent_cd,protocol];var registration=[Sym("let*"),[[Sym("__rtd"),rtd_def],[Sym("__cd"),cd_def]],[Sym("_define-record-type"),[Sym("quote"),record_name],Sym("__rtd"),Sym("__cd")]];var accessor_defs=_.map(fields,function(field){var name=field.accessor_name||Sym(record_name.name+"-"+field.name.name);return[Sym("define"),name,[Sym("record-accessor"),rtd,field.idx]]});var mutator_defs=_.filter(fields,function(field){return field.mutable});mutator_defs=_.map(mutator_defs,function(field){var name=field.mutator_name||Sym(record_name.name+"-"+field.name.name+"-set!");return[Sym("define"),name,[Sym("record-mutator"),rtd,field.idx]]});return deep_array_to_list([Sym("begin"),registration,[Sym("define"),constructor_name,[Sym("record-constructor"),cd]],[Sym("define"),predicate_name,[Sym("record-predicate"),rtd]]].concat(accessor_defs).concat(mutator_defs))});define_libfunc("_define-record-type",3,3,function(ar){assert_symbol(ar[0]);assert_record_td(ar[1]);assert_record_cd(ar[2]);BiwaScheme.Record.define_type(ar[0].name,ar[1],ar[2]);return BiwaScheme.undef});define_syntax("record-type-descriptor",function(x){return deep_array_to_list([Sym("_record-type-descriptor"),[Sym("quote"),x.cdr.car]])});define_libfunc("_record-type-descriptor",1,1,function(ar){assert_symbol(ar[0]);var type=BiwaScheme.Record.get_type(ar[0].name);if(type)return type.rtd;else throw new Error("record-type-descriptor: unknown record type "+ar[0].name)});define_syntax("record-constructor-descriptor",function(x){return deep_array_to_list([Sym("_record-constructor-descriptor"),[Sym("quote"),x.cdr.car]])});define_libfunc("_record-constructor-descriptor",1,1,function(ar){assert_symbol(ar[0]);var type=BiwaScheme.Record.get_type(ar[0].name);if(type)return type.cd;else throw new Error("record-constructor-descriptor: unknown record type "+ar[0].name)});define_libfunc("make-record-type-descriptor",6,6,function(ar){var name=ar[0],parent_rtd=ar[1],uid=ar[2],sealed=ar[3],opaque=ar[4],fields=ar[5];assert_symbol(name);if(parent_rtd)assert_record_td(parent_rtd);if(uid){assert_symbol(uid);var _rtd=BiwaScheme.Record.RTD.NongenerativeRecords[uid.name];if(_rtd){return _rtd}}sealed=!!sealed;opaque=!!opaque;assert_vector(fields);for(var i=0;i<fields.length;i++){var list=fields[i];assert_symbol(list.car,"mutability");assert_symbol(list.cdr.car,"field name");fields[i]=[list.cdr.car.name,list.car==Sym("mutable")]}var rtd=new BiwaScheme.Record.RTD(name,parent_rtd,uid,sealed,opaque,fields);if(uid)BiwaScheme.Record.RTD.NongenerativeRecords[uid.name]=rtd;return rtd});define_libfunc("record-type-descriptor?",1,1,function(ar){return ar[0]instanceof BiwaScheme.Record.RTD});define_libfunc("make-record-constructor-descriptor",3,3,function(ar){var rtd=ar[0],parent_cd=ar[1],protocol=ar[2];assert_record_td(rtd);if(parent_cd)assert_record_cd(parent_cd);if(protocol)assert_procedure(protocol);return new BiwaScheme.Record.CD(rtd,parent_cd,protocol)});define_libfunc("record-constructor",1,1,function(ar){var cd=ar[0];assert_record_cd(cd);return cd.record_constructor()});define_libfunc("record-predicate",1,1,function(ar){var rtd=ar[0];assert_record_td(rtd);return function(args){var obj=args[0];return obj instanceof BiwaScheme.Record&&obj.rtd===rtd}});define_libfunc("record-accessor",2,2,function(ar){var rtd=ar[0],k=ar[1];assert_record_td(rtd);assert_integer(k);for(var _rtd=rtd.parent_rtd;_rtd;_rtd=_rtd.parent_rtd)k+=_rtd.fields.length;return function(args){var record=args[0];var error_msg=rtd.name.name+"-"+rtd.field_name(k)+": "+BiwaScheme.to_write(record)+" is not a "+rtd.name.name;assert(BiwaScheme.isRecord(record),error_msg);var descendant=false;for(var _rtd=record.rtd;_rtd;_rtd=_rtd.parent_rtd){if(_rtd==rtd)descendant=true}assert(descendant,error_msg);return record.get(k)}});define_libfunc("record-mutator",2,2,function(ar){var rtd=ar[0],k=ar[1];assert_record_td(rtd);assert_integer(k);for(var _rtd=rtd.parent_rtd;_rtd;_rtd=_rtd.parent_rtd)k+=_rtd.fields.length;return function(args){var record=args[0],val=args[1];var func_name=rtd.field_name(k);assert_record(record);assert(record.rtd===rtd,func_name+": "+BiwaScheme.to_write(record)+" is not a "+rtd.name.name);assert(!record.rtd.sealed,func_name+": "+rtd.name.name+" is sealed (can't mutate)");record.set(k,val)}});define_libfunc("record?",1,1,function(ar){var obj=ar[0];if(BiwaScheme.isRecord(obj)){if(obj.rtd.opaque)return false;else return true}else return false});define_libfunc("record-rtd",1,1,function(ar){assert_record(ar[0]);return ar[0].rtd});define_libfunc("record-type-name",1,1,function(ar){assert_record_td(ar[0]);return ar[0].name});define_libfunc("record-type-parent",1,1,function(ar){assert_record_td(ar[0]);return ar[0].parent_rtd});define_libfunc("record-type-uid",1,1,function(ar){assert_record_td(ar[0]);return ar[0].uid});define_libfunc("record-type-generative?",1,1,function(ar){assert_record_td(ar[0]);return ar[0].generative});define_libfunc("record-type-sealed?",1,1,function(ar){assert_record_td(ar[0]);return ar[0].sealed});define_libfunc("record-type-opaque?",1,1,function(ar){assert_record_td(ar[0]);return ar[0].opaque});define_libfunc("record-type-field-names",1,1,function(ar){assert_record_td(ar[0]);return _.map(ar[0].fields,function(field){return field.name})});define_libfunc("record-field-mutable?",2,2,function(ar){var rtd=ar[0],k=ar[1];assert_record_td(ar[0]);assert_integer(k);for(var _rtd=rtd.parent_rtd;_rtd;_rtd=_rtd.parent_rtd)k+=_rtd.fields.length;return ar[0].fields[k].mutable});define_libfunc("raise",1,1,function(ar){throw new BiwaScheme.UserError(BiwaScheme.to_write(ar[0]))});define_libfunc("port?",1,1,function(ar){return ar[0]instanceof Port});define_libfunc("textual-port?",1,1,function(ar){assert_port(ar[0]);return!ar[0].is_binary});define_libfunc("binary-port?",1,1,function(ar){assert_port(ar[0]);return ar[0].is_binary});define_libfunc("close-port",1,1,function(ar){assert_port(ar[0]);ar[0].close();return BiwaScheme.undef});define_libfunc("call-with-port",2,2,function(ar){var port=ar[0],proc=ar[1];assert_port(port);assert_closure(proc);return new Call(proc,[port],function(ar){port.close();return ar[0]})});define_libfunc("call-with-string-output-port",1,1,function(ar){var proc=ar[0];assert_procedure(proc);var port=new BiwaScheme.Port.StringOutput;return new Call(proc,[port],function(ar){port.close();return port.output_string()})});define_libfunc("put-char",2,2,function(ar){assert_port(ar[0]);assert_char(ar[1]);ar[0].put_string(ar[1].value);return BiwaScheme.undef});define_libfunc("put-string",2,2,function(ar){assert_port(ar[0]);assert_string(ar[1]);ar[0].put_string(ar[1]);return BiwaScheme.undef});define_libfunc("put-datum",2,2,function(ar){assert_port(ar[0]);ar[0].put_string(to_write(ar[1]));return BiwaScheme.undef});define_libfunc("eof-object",0,0,function(ar){return eof});define_libfunc("eof-object?",1,1,function(ar){return ar[0]===eof});define_libfunc("input-port?",1,1,function(ar){assert_port(ar[0]);return ar[0].is_input});define_libfunc("output-port?",1,1,function(ar){assert_port(ar[0]);return ar[0].is_output});define_libfunc("current-input-port",0,0,function(ar){return Port.current_input});define_libfunc("current-output-port",0,0,function(ar){return Port.current_output});define_libfunc("current-error-port",0,0,function(ar){return Port.current_error});define_libfunc("close-input-port",1,1,function(ar){assert_port(ar[0]);if(!ar[0].is_input)throw new Error("close-input-port: port is not input port");ar[0].close();return BiwaScheme.undef});define_libfunc("close-output-port",1,1,function(ar){assert_port(ar[0]);if(!ar[0].is_output)throw new Error("close-output-port: port is not output port");ar[0].close();return BiwaScheme.undef});define_libfunc("read",0,1,function(ar){var port=ar[0]||Port.current_input;assert_port(port);return port.get_string(function(str){return Interpreter.read(str)})});define_libfunc("write-char",1,2,function(ar){var port=ar[1]||Port.current_output;

assert_char(ar[0]);port.put_string(ar[0].value);return BiwaScheme.undef});define_libfunc("newline",0,1,function(ar){var port=ar[0]||Port.current_output;port.put_string("\n");return BiwaScheme.undef});define_libfunc("display",1,2,function(ar){var port=ar[1]||Port.current_output;port.put_string(to_display(ar[0]));return BiwaScheme.undef});define_libfunc("write",1,2,function(ar){var port=ar[1]||Port.current_output;assert_port(port);port.put_string(to_write(ar[0]));return BiwaScheme.undef});define_libfunc("bitwise-not",1,1,function(ar){return~ar[0]});define_libfunc("bitwise-and",1,null,function(ar){return _.reduce(ar,function(ret,item){return ret&item})});define_libfunc("bitwise-ior",1,null,function(ar){return _.reduce(ar,function(ret,item){return ret|item})});define_libfunc("bitwise-xor",1,null,function(ar){return _.reduce(ar,function(ret,item){return ret^item})});define_libfunc("bitwise-if",3,3,function(ar){return ar[0]&ar[1]|~ar[0]&ar[2]});define_libfunc("bitwise-bit-count",1,1,function(ar){var e=Math.abs(ar[0]),ret=0;for(;e!=0;e>>=1){if(e&1)ret++}return ret});define_libfunc("bitwise-length",1,1,function(ar){var e=Math.abs(ar[0]),ret=0;for(;e!=0;e>>=1){ret++}return ret});define_libfunc("bitwise-first-bit-set",1,1,function(ar){var e=Math.abs(ar[0]),ret=0;if(e==0)return-1;for(;e!=0;e>>=1){if(e&1)return ret;ret++}});define_libfunc("bitwise-bit-set?",2,2,function(ar){return!!(ar[0]&1<<ar[1])});define_libfunc("bitwise-copy-bit",3,3,function(ar){var mask=1<<ar[1];return mask&ar[2]<<ar[1]|~mask&ar[0]});define_libfunc("bitwise-bit-field",3,3,function(ar){var mask=~(-1<<ar[2]);return(mask&ar[0])>>ar[1]});define_libfunc("bitwise-copy-bit-field",4,4,function(ar){var dst=ar[0],start=ar[1],end=ar[2],src=ar[3];var mask=~(-1<<end)&-1<<start;return mask&src<<start|~mask&dst});define_libfunc("bitwise-arithmetic-shift",2,2,function(ar){return ar[1]>=0?ar[0]<<ar[1]:ar[0]>>-ar[1]});define_libfunc("bitwise-arithmetic-shift-left",2,2,function(ar){return ar[0]<<ar[1]});define_libfunc("bitwise-arithmetic-shift-right",2,2,function(ar){return ar[0]>>ar[1]});define_libfunc("bitwise-rotate-bit-field",4,4,function(ar){var n=ar[0],start=ar[1],end=ar[2],count=ar[3];var width=end-start;if(width<=0)return n;count%=width;var orig_field=(~(-1<<end)&n)>>start;var rotated_field=orig_field<<count|orig_field>>width-count;var mask=~(-1<<end)&-1<<start;return mask&rotated_field<<start|~mask&n});define_libfunc("bitwise-reverse-bit-field",3,3,function(ar){var ret=n=ar[0],start=ar[1],end=ar[2];var orig_field=(~(-1<<end)&n)>>start;for(var i=0;i<end-start;i++,orig_field>>=1){var bit=orig_field&1;var setpos=end-1-i;var mask=1<<setpos;ret=mask&bit<<setpos|~mask&ret}return ret});define_libfunc("make-eq-hashtable",0,1,function(ar){return new Hashtable(Hashtable.eq_hash,Hashtable.eq_equiv)});define_libfunc("make-eqv-hashtable",0,1,function(ar){return new Hashtable(Hashtable.eqv_hash,Hashtable.eqv_equiv)});define_libfunc("make-hashtable",2,3,function(ar){assert_procedure(ar[0]);assert_procedure(ar[1]);return new Hashtable(ar[0],ar[1])});define_libfunc("hashtable?",1,1,function(ar){return ar[0]instanceof Hashtable});define_libfunc("hashtable-size",1,1,function(ar){assert_hashtable(ar[0]);return ar[0].keys().length});BiwaScheme.find_hash_pair=function(hash,key,callbacks){return new Call(hash.hash_proc,[key],function(ar){var hashed=ar[0];var candidate_pairs=hash.candidate_pairs(hashed);if(!candidate_pairs){return callbacks.on_not_found(hashed)}return Call.foreach(candidate_pairs,{call:function(pair){return new Call(hash.equiv_proc,[key,pair[0]])},result:function(equal,pair){if(equal){return callbacks.on_found(pair,hashed)}},finish:function(){return callbacks.on_not_found(hashed)}})})};define_libfunc("hashtable-ref",3,3,function(ar){var hash=ar[0],key=ar[1],ifnone=ar[2];assert_hashtable(hash);return BiwaScheme.find_hash_pair(hash,key,{on_found:function(pair){return pair[1]},on_not_found:function(hashed){return ifnone}})});define_libfunc("hashtable-set!",3,3,function(ar){var hash=ar[0],key=ar[1],value=ar[2];assert_hashtable(hash);assert(hash.mutable,"hashtable is not mutable");return BiwaScheme.find_hash_pair(hash,key,{on_found:function(pair){pair[1]=value;return BiwaScheme.undef},on_not_found:function(hashed){hash.add_pair(hashed,key,value);return BiwaScheme.undef}})});define_libfunc("hashtable-delete!",2,2,function(ar){var hash=ar[0],key=ar[1];assert_hashtable(hash);assert(hash.mutable,"hashtable is not mutable");return BiwaScheme.find_hash_pair(hash,key,{on_found:function(pair,hashed){hash.remove_pair(hashed,pair);return BiwaScheme.undef},on_not_found:function(hashed){return BiwaScheme.undef}})});define_libfunc("hashtable-contains?",2,2,function(ar){var hash=ar[0],key=ar[1];assert_hashtable(hash);return BiwaScheme.find_hash_pair(hash,key,{on_found:function(pair){return true},on_not_found:function(hashed){return false}})});define_libfunc("hashtable-update!",4,4,function(ar){var hash=ar[0],key=ar[1],proc=ar[2],ifnone=ar[3];assert_hashtable(hash);assert(hash.mutable,"hashtable is not mutable");assert_procedure(proc);return BiwaScheme.find_hash_pair(hash,key,{on_found:function(pair,hashed){return new Call(proc,[pair[1]],function(ar){pair[1]=ar[0];return BiwaScheme.undef})},on_not_found:function(hashed){return new Call(proc,[ifnone],function(ar){hash.add_pair(hashed,key,ar[0]);return BiwaScheme.undef})}})});define_libfunc("hashtable-copy",1,2,function(ar){var mutable=ar[1]===undefined?false:!!ar[1];assert_hashtable(ar[0]);return ar[0].create_copy(mutable)});define_libfunc("hashtable-clear!",0,1,function(ar){assert_hashtable(ar[0]);assert(ar[0].mutable,"hashtable is not mutable");ar[0].clear();return BiwaScheme.undef});define_libfunc("hashtable-keys",1,1,function(ar){assert_hashtable(ar[0]);return ar[0].keys()});define_libfunc("hashtable-entries",1,1,function(ar){assert_hashtable(ar[0]);return new Values([ar[0].keys(),ar[0].values()])});define_libfunc("hashtable-equivalence-function",1,1,function(ar){assert_hashtable(ar[0]);return ar[0].equiv_proc});define_libfunc("hashtable-hash-function",1,1,function(ar){assert_hashtable(ar[0]);return ar[0].hash_proc});define_libfunc("hashtable-mutable?",1,1,function(ar){assert_hashtable(ar[0]);return ar[0].mutable});define_libfunc("equal-hash",0,0,function(ar){return Hashtable.equal_hash});define_libfunc("string-hash",0,0,function(ar){return Hashtable.string_hash});define_libfunc("string-ci-hash",0,0,function(ar){return Hashtable.string_ci_hash});define_libfunc("symbol-hash",0,0,function(ar){return Hashtable.symbol_hash});define_libfunc("make-enumeration",1,1,function(ar){assert_list(ar[0]);var members=ar[0].to_array();var enum_type=new BiwaScheme.Enumeration.EnumType(members);return enum_type.universe()});define_libfunc("enum-set-universe",1,1,function(ar){assert_enum_set(ar[0]);return ar[0].enum_type.universe()});define_libfunc("enum-set-indexer",1,1,function(ar){assert_enum_set(ar[0]);return ar[0].enum_type.indexer()});define_libfunc("enum-set-constructor",1,1,function(ar){assert_enum_set(ar[0]);return ar[0].enum_type.constructor()});define_libfunc("enum-set->list",1,1,function(ar){assert_enum_set(ar[0]);return ar[0].symbol_list()});define_libfunc("enum-set-member?",2,2,function(ar){assert_symbol(ar[0]);assert_enum_set(ar[1]);return ar[1].is_member(ar[0])});define_libfunc("enum-set-subset?",2,2,function(ar){assert_enum_set(ar[0]);assert_enum_set(ar[1]);return ar[0].is_subset(ar[1])});define_libfunc("enum-set=?",2,2,function(ar){assert_enum_set(ar[0]);assert_enum_set(ar[1]);return ar[0].equal_to(ar[1])});define_libfunc("enum-set-union",2,2,function(ar){assert_enum_set(ar[0]);assert_enum_set(ar[1]);assert(ar[0].enum_type===ar[1].enum_type,"two enum-sets must be the same enum-type","enum-set-union");return ar[0].union(ar[1])});define_libfunc("enum-set-intersection",2,2,function(ar){assert_enum_set(ar[0]);assert_enum_set(ar[1]);return ar[0].intersection(ar[1])});define_libfunc("enum-set-difference",2,2,function(ar){assert_enum_set(ar[0]);assert_enum_set(ar[1]);return ar[0].difference(ar[1])});define_libfunc("enum-set-complement",1,1,function(ar){assert_enum_set(ar[0]);return ar[0].complement()});define_libfunc("enum-set-projection",2,2,function(ar){assert_enum_set(ar[0]);assert_enum_set(ar[1]);return ar[0].projection(ar[1])});define_syntax("define-enumeration",function(x){var type_name=x.cdr.car;assert(BiwaScheme.isSymbol(type_name),"expected symbol for type_name","define-enumeration");type_name=type_name.name;var members=x.cdr.cdr.car;assert(BiwaScheme.isList(members),"expected list of symbol for members","define-enumeration");members=members.to_array();var constructor_name=x.cdr.cdr.cdr.car;assert(BiwaScheme.isSymbol(constructor_name),"expected symbol for constructor_name","define-enumeration");constructor_name=constructor_name.name;var enum_type=new BiwaScheme.Enumeration.EnumType(members);define_syntax(type_name,function(x){assert(!BiwaScheme.isNil(x.cdr),"an argument is needed",type_name);var arg=x.cdr.car;assert_symbol(arg,type_name);assert(_.include(enum_type.members,arg),arg.name+" is not included in the universe: "+BiwaScheme.to_write(enum_type.members),type_name);return BiwaScheme.List(Sym("quote"),arg)});define_syntax(constructor_name,function(x){assert_list(x.cdr,constructor_name);var symbols=x.cdr.to_array();_.each(symbols,function(arg){assert_symbol(arg,constructor_name);assert(_.include(enum_type.members,arg),arg.name+" is not included in the universe: "+BiwaScheme.to_write(enum_type.members),constructor_name)});return new BiwaScheme.Enumeration.EnumSet(enum_type,symbols)})});define_libfunc("eval",1,1,function(ar,intp){var expr=ar[0];var intp2=new Interpreter(intp);return intp2.evaluate(expr.to_write())})}if(typeof BiwaScheme!="object")BiwaScheme={};with(BiwaScheme){define_libfunc("js-eval",1,1,function(ar){return eval(ar[0])});define_libfunc("js-ref",2,2,function(ar){if(_.isString(ar[1])){return ar[0][ar[1]]}else{assert_symbol(ar[1]);return ar[0][ar[1].name]}});define_libfunc("js-set!",3,3,function(ar){assert_string(ar[1]);ar[0][ar[1]]=ar[2];return BiwaScheme.undef});define_libfunc("js-call",1,null,function(ar){var js_func=ar.shift();assert_function(js_func);var receiver=null;return js_func.apply(receiver,ar)});define_libfunc("js-invoke",2,null,function(ar){var js_obj=ar.shift();var func_name=ar.shift();if(!_.isString(func_name)){assert_symbol(func_name);func_name=func_name.name}if(js_obj[func_name])return js_obj[func_name].apply(js_obj,ar);else throw new Error("js-invoke: function "+func_name+" is not defined")});define_libfunc("js-invocation",2,null,function(ar,intp){var receiver=ar.shift();if(BiwaScheme.isSymbol(receiver)){receiver=eval(receiver.name)}var v=receiver;_.each(ar,function(callspec){if(BiwaScheme.isSymbol(callspec)){v=v[callspec.name]}else if(BiwaScheme.isList(callspec)){var args=callspec.to_array();assert_symbol(args[0]);var method=args.shift().name;args=_.map(args,function(arg){if(BiwaScheme.isClosure(arg)){return BiwaScheme.js_closure(arg,intp)}else if(BiwaScheme.isList(arg)){var o={};arg.foreach(function(pair){assert_symbol(pair.car);o[pair.car.name]=pair.cdr});return o}else return arg});if(!_.isFunction(v[method])){throw new BiwaScheme.Error("js-invocation: the method `"+method+"' not found")}v=v[method].apply(v,args)}else{throw new BiwaScheme.Error("js-invocation: expected list or symbol for callspec but got "+BiwaScheme.inspect(callspec))}});return v});define_syntax("..",function(x){if(x.cdr==nil){throw new Error("malformed ..")}return new Pair(Sym("js-invocation"),x.cdr)});define_libfunc("js-new",1,null,function(ar,intp){var array_to_obj=function(ary){if(ary.length%2!=0)throw new Error("js-new: odd number of key-value pair");var obj={};for(var i=0;i<ary.length;i+=2){var key=ary[i],value=ary[i+1];assert_symbol(key);if(value.closure_p===true)value=BiwaScheme.js_closure(value,intp);obj[key.name]=value}return obj};var ctor=ar.shift();assert_string(ctor);if(ar.length==0){return eval("new "+ctor+"()")}else{var args=[];for(var i=0;i<ar.length;i++){if(ar[i]instanceof Symbol){args.push(array_to_obj(ar.slice(i)));break}else{args.push(ar[i])}}var args_str=_.map(ar,function(value,i){return"args['"+i+"']"}).join(",");return eval("new "+ctor+"("+args_str+")")}});define_libfunc("js-obj",0,null,function(ar){if(ar.length%2!=0){throw new Error("js-obj: number of arguments must be even")}var obj={};for(i=0;i<ar.length/2;i++){assert_string(ar[i*2]);obj[ar[i*2]]=ar[i*2+1]}return obj});BiwaScheme.js_closure=function(proc,intp){var intp2=new Interpreter(intp);return function(){return intp2.invoke_closure(proc,_.toArray(arguments))}};define_libfunc("js-closure",1,1,function(ar,intp){assert_closure(ar[0]);return BiwaScheme.js_closure(ar[0],intp)});define_libfunc("js-null?",1,1,function(ar){return ar[0]===null});define_libfunc("js-undefined?",1,1,function(ar){return ar[0]===undefined});define_libfunc("js-function?",1,1,function(ar){return _.isFunction(ar[0])});define_libfunc("js-array-to-list",1,1,function(ar){BiwaScheme.deprecate("js-array-to-list","1.0","js-array->list");return BiwaScheme.array_to_list(ar[0])});define_libfunc("js-array->list",1,1,function(ar){return BiwaScheme.array_to_list(ar[0])});define_libfunc("list-to-js-array",1,1,function(ar){BiwaScheme.deprecate("list-to-js-array","1.0","list->js-array");return ar[0].to_array()});define_libfunc("list->js-array",1,1,function(ar){return ar[0].to_array()});BiwaScheme.alist_to_js_obj=function(alist){if(alist===nil){return{}}assert_list(alist);var obj={};alist.foreach(function(item){assert_string(item.car);obj[item.car]=item.cdr});return obj};define_libfunc("alist-to-js-obj",1,1,function(ar){BiwaScheme.deprecate("alist-to-js-obj","1.0","alist->js-obj");return BiwaScheme.alist_to_js_obj(ar[0])});define_libfunc("alist->js-obj",1,1,function(ar){return BiwaScheme.alist_to_js_obj(ar[0])});BiwaScheme.js_obj_to_alist=function(obj){if(obj===undefined){return BiwaScheme.nil}var arr=[];_.each(obj,function(val,key){arr.push(new Pair(key,val))});var alist=BiwaScheme.array_to_list(arr);return alist};define_libfunc("js-obj-to-alist",1,1,function(ar){BiwaScheme.deprecate("js-obj-to-alist","1.0","js-obj->alist");return BiwaScheme.js_obj_to_alist(ar[0])});define_libfunc("js-obj->alist",1,1,function(ar){return BiwaScheme.js_obj_to_alist(ar[0])});define_libfunc("timer",2,2,function(ar,intp){var proc=ar[0],sec=ar[1];assert_closure(proc);assert_real(sec);var intp2=new Interpreter(intp);setTimeout(function(){intp2.invoke_closure(proc)},sec*1e3);return BiwaScheme.undef});define_libfunc("set-timer!",2,2,function(ar,intp){var proc=ar[0],sec=ar[1];assert_closure(proc);assert_real(sec);var intp2=new Interpreter(intp);return setInterval(function(){intp2.invoke_closure(proc)},sec*1e3)});define_libfunc("clear-timer!",1,1,function(ar){var timer_id=ar[0];clearInterval(timer_id);return BiwaScheme.undef});define_libfunc("sleep",1,1,function(ar){var sec=ar[0];assert_real(sec);return new BiwaScheme.Pause(function(pause){setTimeout(function(){pause.resume(nil)},sec*1e3)})});var define_console_func=function(name){define_libfunc("console-"+name,1,null,function(ar){var con=window.console;if(con){var vals=_.map(ar,function(item){return BiwaScheme.inspect(item,{fallback:item})});con[name].apply(con,vals)}return ar[0]})};define_console_func("debug");define_console_func("log");define_console_func("info");define_console_func("warn");define_console_func("error")}if(typeof BiwaScheme!="object")BiwaScheme={};with(BiwaScheme){define_libfunc("html-escape",1,1,function(ar){assert_string(ar[0]);return _.escape(ar[0])});BiwaScheme.inspect_objs=function(objs){return _.map(objs,BiwaScheme.inspect).join(", ")};define_libfunc("inspect",1,null,function(ar){return BiwaScheme.inspect_objs(ar)});define_libfunc("inspect!",1,null,function(ar){puts(BiwaScheme.inspect_objs(ar));return BiwaScheme.undef});BiwaScheme.json2sexp=function(json){switch(true){case _.isNumber(json)||_.isString(json)||json===true||json===false:return json;case _.isArray(json):return array_to_list(_.map(json,json2sexp));case typeof json=="object":var ls=nil;for(key in json){ls=new Pair(new Pair(key,json2sexp(json[key])),ls)}return ls;default:throw new Error("json->sexp: detected invalid value for json: "+BiwaScheme.inspect(json))}throw new Bug("must not happen")};define_libfunc("json->sexp",1,1,function(ar){return json2sexp(ar[0])});define_libfunc("vector-push!",2,null,function(ar){assert_vector(ar[0]);for(var i=1;i<ar.length;i++){ar[0].push(ar[i])}return ar[0]});define_libfunc("identity",1,1,function(ar){return ar[0]});define_syntax("inc!",function(x){var target=x.cdr.car;return List(Sym("set!"),target,List(Sym("+"),target,1))});define_syntax("dec!",function(x){var target=x.cdr.car;return List(Sym("set!"),target,List(Sym("-"),target,1))});define_libfunc("string-concat",1,1,function(ar){assert_list(ar[0]);return ar[0].to_array().join("")});define_libfunc("string-split",2,2,function(ar){assert_string(ar[0]);assert_string(ar[1]);return array_to_list(ar[0].split(ar[1]))});define_libfunc("string-join",1,2,function(ar){assert_list(ar[0]);var delim="";if(ar[1]){assert_string(ar[1]);delim=ar[1]}return ar[0].to_array().join(delim)});define_libfunc("intersperse",2,2,function(ar){var item=ar[0],ls=ar[1];assert_list(ls);var ret=[];_.each(ls.to_array().reverse(),function(x){ret.push(x);ret.push(item)});ret.pop();return array_to_list(ret)});define_libfunc("map-with-index",2,null,function(ar){var proc=ar.shift(),lists=ar;_.each(lists,assert_list);var results=[],i=0;return Call.multi_foreach(lists,{call:function(xs){var args=_.map(xs,function(x){return x.car});args.unshift(i);i++;return new Call(proc,args)},result:function(res){results.push(res)},finish:function(){return array_to_list(results)}})});define_syntax("dotimes",function(x){var spec=x.cdr.car,bodies=x.cdr.cdr;var variable=spec.car,limit=spec.cdr.car,result=spec.cdr.cdr.car;var tlimit=BiwaScheme.gensym();var do_vars=deep_array_to_list([[tlimit,limit],[variable,0,[Sym("+"),variable,1]]]);var do_check=deep_array_to_list([[Sym(">="),variable,tlimit],result]);return new Pair(Sym("do"),new Pair(do_vars,new Pair(do_check,bodies)))});var sort_with_comp=function(ary,proc,intp){return ary.sort(function(a,b){var intp2=new BiwaScheme.Interpreter(intp);return intp2.invoke_closure(proc,[a,b])})};define_libfunc("list-sort/comp",1,2,function(ar,intp){assert_procedure(ar[0]);assert_list(ar[1]);return array_to_list(sort_with_comp(ar[1].to_array(),ar[0],intp))});define_libfunc("vector-sort/comp",1,2,function(ar,intp){assert_procedure(ar[0]);assert_vector(ar[1]);return sort_with_comp(_.clone(ar[1]),ar[0],intp)});define_libfunc("vector-sort/comp!",1,2,function(ar,intp){assert_procedure(ar[0]);assert_vector(ar[1]);sort_with_comp(ar[1],ar[0],intp);return BiwaScheme.undef});var rearrange_args=function(expected,given){var args=[];var dotpos=(new Compiler).find_dot_pos(expected);if(dotpos==-1)args=given;else{for(var i=0;i<dotpos;i++){args[i]=given[i]}args[i]=array_to_list(given.slice(i))}return args};define_syntax("define-macro",function(x){var head=x.cdr.car;var expected_args;if(head instanceof Pair){var name=head.car;expected_args=head.cdr;var body=x.cdr.cdr;var lambda=new Pair(Sym("lambda"),new Pair(expected_args,body))}else{var name=head;var lambda=x.cdr.cdr.car;expected_args=lambda.cdr.car}var opc=Compiler.compile(lambda);if(opc[1]!=0)throw new Bug("you cannot use free variables in macro expander (or define-macro must be on toplevel)");var cls=[opc[2]];TopEnv[name.name]=new Syntax(name.name,function(sexp){var given_args=sexp.to_array();given_args.shift();var intp=new Interpreter;var args=rearrange_args(expected_args,given_args);var result=intp.invoke_closure(cls,args);return result});return BiwaScheme.undef});var macroexpand_1=function(x){if(x instanceof Pair){if(x.car instanceof Symbol&&TopEnv[x.car.name]instanceof Syntax){var transformer=TopEnv[x.car.name];x=transformer.transform(x)}else throw new Error("macroexpand-1: `"+to_write_ss(x)+"' is not a macro")}return x};define_syntax("%macroexpand",function(x){var expanded=BiwaScheme.Interpreter.expand(x.cdr.car);return List(Sym("quote"),expanded)});define_syntax("%macroexpand-1",function(x){var expanded=macroexpand_1(x.cdr.car);return List(Sym("quote"),expanded)});define_libfunc("macroexpand",1,1,function(ar){return BiwaScheme.Interpreter.expand(ar[0])});define_libfunc("macroexpand-1",1,1,function(ar){return macroexpand_1(ar[0])});define_libfunc("gensym",0,0,function(ar){return BiwaScheme.gensym()});define_libfunc("print",1,null,function(ar){_.map(ar,function(item){puts(to_display(item),true)});puts("");return BiwaScheme.undef});define_libfunc("write-to-string",1,1,function(ar){return to_write(ar[0])});define_libfunc("read-from-string",1,1,function(ar){assert_string(ar[0]);return Interpreter.read(ar[0])});define_libfunc("port-closed?",1,1,function(ar){assert_port(ar[0]);return!ar[0].is_open});define_libfunc("with-output-to-port",2,2,function(ar){var port=ar[0],proc=ar[1];assert_port(port);assert_procedure(proc);var original_port=BiwaScheme.Port.current_output;BiwaScheme.Port.current_output=port;return new Call(proc,[port],function(ar){port.close();BiwaScheme.Port.current_output=original_port;return ar[0]})});define_syntax("let1",function(x){var vari=x.cdr.car;var expr=x.cdr.cdr.car;var body=x.cdr.cdr.cdr;return new Pair(new Pair(Sym("lambda"),new Pair(new Pair(vari,nil),body)),new Pair(expr,nil))});var assert_regexp=function(obj,fname){if(!(obj instanceof RegExp))throw new Error(fname+": regexp required, but got "+to_write(obj))};define_libfunc("string->regexp",1,1,function(ar){assert_string(ar[0],"string->regexp");return new RegExp(ar[0])});define_libfunc("regexp?",1,1,function(ar){return ar[0]instanceof RegExp});define_libfunc("regexp->string",1,1,function(ar){assert_regexp(ar[0],"regexp->string");return ar[0].toString().slice(1,-1)});define_libfunc("regexp-exec",2,2,function(ar){var rexp=ar[0];if(_.isString(ar[0])){rexp=new RegExp(ar[0])}assert_regexp(rexp,"regexp-exec");assert_string(ar[1],"regexp-exec");var ret=rexp.exec(ar[1]);return ret===null?false:array_to_list(ret)});define_libfunc("regexp-replace-all",3,3,function(ar){var pat=ar[0];if(_.isString(pat)){var rexp=new RegExp(pat,"g")}else{assert_regexp(pat);var rexp=new RegExp(pat.source,"g")}assert_string(ar[1]);assert_string(ar[2]);return ar[1].replace(rexp,ar[2])})}(function(){if(BiwaScheme.on_node){var node={fs:require("fs"),path:require("path"),process:process}}var define_node_libfunc=function(){var args=_.toArray(arguments);if(BiwaScheme.on_node){BiwaScheme.define_libfunc.apply(null,args)}else{var func_name=args[0];var func=function(ar){throw new BiwaScheme.Error("the function '"+func_name+"' "+"is not supported in the browser "+"(works only on Node.js).")};args.pop();args.push(func);BiwaScheme.define_libfunc.apply(null,args)}};define_node_libfunc("file-exists?",1,1,function(ar){assert_string(ar[0]);return node.fs.existsSync(ar[0])});define_node_libfunc("delete-file",1,1,function(ar){assert_string(ar[0]);node.fs.unlinkSync(ar[0]);return BiwaScheme.undef});define_node_libfunc("command-line",0,0,function(ar){return BiwaScheme.List.apply(null,node.process.argv)});define_node_libfunc("exit",0,1,function(ar){var obj=ar[0];var code=_.isUndefined(obj)?0:obj===false?1:Number(obj);node.process.exit(code)});define_node_libfunc("get-environment-variable",1,1,function(ar){assert_string(ar[0]);var val=node.process.env[ar[0]];return _.isUndefined(val)?false:val});define_node_libfunc("get-environment-variables",0,0,function(ar){return BiwaScheme.js_obj_to_alist(node.process.env)})})();with(BiwaScheme){define_libfunc("iota",1,3,function(ar){var count=ar[0];var start=ar[1]||0;var step=ar[2]===undefined?1:ar[2];assert_integer(count);assert_number(start);assert_number(step);var a=[],n=start;for(var i=0;i<count;i++){a.push(n);n+=step}return array_to_list(a)});var copy_pair=function(pair){var car=BiwaScheme.isPair(pair.car)?copy_pair(pair.car):pair.car;var cdr=BiwaScheme.isPair(pair.cdr)?copy_pair(pair.cdr):pair.cdr;return new Pair(car,cdr)};define_libfunc("list-copy",1,1,function(ar){if(BiwaScheme.isPair(ar[0])){return copy_pair(ar[0])}else{return BiwaScheme.nil}});define_libfunc("open-input-string",1,1,function(ar){assert_string(ar[0]);return new Port.StringInput(ar[0])});define_libfunc("open-output-string",0,0,function(ar){return new Port.StringOutput});define_libfunc("get-output-string",1,1,function(ar){assert_port(ar[0]);if(!(ar[0]instanceof Port.StringOutput))throw new Error("get-output-string: port must be made by 'open-output-string'");return ar[0].output_string()});define_syntax("receive",function(x){assert(BiwaScheme.isPair(x.cdr),"missing formals","receive");var formals=x.cdr.car;assert(BiwaScheme.isPair(x.cdr.cdr),"missing expression","receive");var expression=x.cdr.cdr.car;var body=x.cdr.cdr.cdr;return deep_array_to_list([Sym("call-with-values"),[Sym("lambda"),BiwaScheme.nil,expression],new BiwaScheme.Pair(Sym("lambda"),new BiwaScheme.Pair(formals,body))])});define_libfunc("current-date",0,1,function(ar){return new Date});define_libfunc("date?",1,1,function(ar){return ar[0]instanceof Date});define_libfunc("date-nanosecond",1,1,function(ar){assert_date(ar[0]);return ar[0].getMilliseconds()*1e6});define_libfunc("date-millisecond",1,1,function(ar){assert_date(ar[0]);return ar[0].getMilliseconds()});define_libfunc("date-second",1,1,function(ar){assert_date(ar[0]);return ar[0].getSeconds()});define_libfunc("date-minute",1,1,function(ar){assert_date(ar[0]);return ar[0].getMinutes()});define_libfunc("date-hour",1,1,function(ar){assert_date(ar[0]);return ar[0].getHours()});define_libfunc("date-day",1,1,function(ar){assert_date(ar[0]);return ar[0].getDate()});define_libfunc("date-month",1,1,function(ar){assert_date(ar[0]);return ar[0].getMonth()+1});define_libfunc("date-year",1,1,function(ar){assert_date(ar[0]);return ar[0].getFullYear()});define_libfunc("date-week-day",1,1,function(ar){assert_date(ar[0]);return ar[0].getDay()});BiwaScheme.date_names={weekday:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],full_weekday:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],month:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],full_month:["January","February","March","April","May","June","July","August","September","Octorber","November","December"]};BiwaScheme.date2string=function(date,format){var zeropad=function(n){return n<10?"0"+n:""+n};var spacepad=function(n){return n<10?" "+n:""+n};var getter={a:function(x){return date_names.weekday[x.getDay()]},A:function(x){return date_names.full_weekday[x.getDay()]},b:function(x){return date_names.month[x.getMonth()]},B:function(x){return date_names.full_month[x.getMonth()]},c:function(x){return x.toString()},d:function(x){return zeropad(x.getDate())},D:function(x){return getter.d(x)+getter.m(x)+getter.y(x)},e:function(x){return spacepad(x.getDate())},f:function(x){return x.getSeconds()+x.getMilliseconds()/1e3},h:function(x){return date_names.month[x.getMonth()]},H:function(x){return zeropad(x.getHours())},I:function(x){var h=x.getHours();return zeropad(h<13?h:h-12)},j:function(x){throw new Bug("not implemented: day of year")},k:function(x){return spacepad(x.getHours())},l:function(x){var h=x.getHours();return spacepad(h<13?h:h-12)},m:function(x){return zeropad(x.getMonth()+1)},M:function(x){return zeropad(x.getMinutes())},n:function(x){return"\n"},N:function(x){throw new Bug("not implemented: nanoseconds")},p:function(x){return x.getHours()<13?"AM":"PM"},r:function(x){return getter.I(x)+":"+getter.M(x)+":"+getter.S(x)+" "+getter.p(x)},s:function(x){return Math.floor(x.getTime()/1e3)},S:function(x){return zeropad(x.getSeconds())},t:function(x){return"	"},T:function(x){return getter.H(x)+":"+getter.M(x)+":"+getter.S(x)},U:function(x){throw new Bug("not implemented: weeknum(0~, Sun)")},V:function(x){throw new Bug("not implemented: weeknum(1~, Sun?)")},w:function(x){return x.getDay()},W:function(x){throw new Bug("not implemented: weeknum(0~, Mon)")},x:function(x){throw new Bug("not implemented: weeknum(1~, Mon)")},X:function(x){return getter.Y(x)+"/"+getter.m(x)+"/"+getter.d(x)},y:function(x){return x.getFullYear()%100},Y:function(x){return x.getFullYear()},z:function(x){throw new Bug("not implemented: time-zone")},Z:function(x){throw new Bug("not implemented: symbol time zone")},1:function(x){throw new Bug("not implemented: ISO-8601 year-month-day format")},2:function(x){throw new Bug("not implemented: ISO-8601 hour-minute-second-timezone format")},3:function(x){throw new Bug("not implemented: ISO-8601 hour-minute-second format")},4:function(x){throw new Bug("not implemented: ISO-8601 year-month-day-hour-minute-second-timezone format")},5:function(x){throw new Bug("not implemented: ISO-8601 year-month-day-hour-minute-second format")}};return format.replace(/~([\w1-5~])/g,function(str,x){var func=getter[x];if(func)return func(date);else if(x=="~")return"~";else return x})};define_libfunc("date->string",1,2,function(ar){assert_date(ar[0]);if(ar[1]){assert_string(ar[1]);return date2string(ar[0],ar[1])}else return ar[0].toString()});define_libfunc("parse-date",1,1,function(ar){assert_string(ar[0]);return new Date(Date.parse(ar[0]))});define_libfunc("random-integer",1,1,function(ar){var n=ar[0];assert_integer(n);if(n<0)throw new Error("random-integer: the argument must be >= 0");else return Math.floor(Math.random()*ar[0])});define_libfunc("random-real",0,0,function(ar){return Math.random()});define_libfunc("format",1,null,function(ar){if(_.isString(ar[0])){var port=null,format_str=ar.shift()}else if(ar[0]===false){ar.shift();var port=null,format_str=ar.shift()}else if(ar[0]===true){ar.shift();var port=BiwaScheme.Port.current_output,format_str=ar.shift()}else{var port=ar.shift(),format_str=ar.shift();assert_port(port)}var str=format_str.replace(/~[as]/g,function(matched){assert(ar.length>0,"insufficient number of arguments","format");if(matched=="~a")return BiwaScheme.to_display(ar.shift());else return BiwaScheme.to_write(ar.shift())}).replace(/~%/,"\n").replace(/~~/,"~");if(port){port.put_string(str);return BiwaScheme.undef}else{return str}});var user_write_ss=function(ar){puts(write_ss(ar[0]),true);return BiwaScheme.undef};define_libfunc("write/ss",1,2,user_write_ss);define_libfunc("write-with-shared-structure",1,2,user_write_ss);define_libfunc("write*",1,2,user_write_ss);define_libfunc("vector-append",2,null,function(ar){var vec=[];return vec.concat.apply(vec,ar)});define_libfunc("vector-copy",1,1,function(ar){assert_vector(ar[0]);return _.clone(ar[0])})}if(typeof BiwaScheme!="object")BiwaScheme={};with(BiwaScheme){define_libfunc("read-line",0,1,function(ar){var port=ar[0]||Port.current_input;assert_port(port);return port.get_string()});define_libfunc("element-empty!",1,1,function(ar){if($(ar[0]).attr("value")){return $(ar[0]).val("")}else{return $(ar[0]).empty()}});alias_libfunc("element-empty!","element-clear!");define_libfunc("element-visible?",1,1,function(ar){return $(ar[0]).is(":visible")});define_libfunc("element-toggle!",1,1,function(ar){return $(ar[0]).toggle()});define_libfunc("element-hide!",1,1,function(ar){return $(ar[0]).hide()});define_libfunc("element-show!",1,1,function(ar){return $(ar[0]).show()});define_libfunc("element-remove!",1,1,function(ar){return $(ar[0]).remove()});define_libfunc("element-update!",2,2,function(ar){return $(ar[0]).html(ar[1])});define_libfunc("element-replace!",2,2,function(ar){return $(ar[0]).replaceWith(ar[1])});define_libfunc("element-insert!",2,2,function(ar){return $(ar[0]).append(ar[1])});define_libfunc("element-wrap!",3,3,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-ancestors",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-descendants",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-first-descendant",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-immediate-descendants",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-previous-sibling",1,1,function(ar){
throw new Bug("not yet implemented")});define_libfunc("element-next-sibling",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-siblings",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-match?",2,2,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-up",3,3,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-down",3,3,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-previous",3,3,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-next",3,3,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-select",1,1,function(ar){$(ar[0]).select()});define_libfunc("element-adjacent",0,0,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-identify",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-read-attribute",2,2,function(ar){assert_string(ar[1]);return $(ar[0]).attr(ar[1])});define_libfunc("element-write-attribute",3,3,function(ar){BiwaScheme.deprecate("element-write-attribute","1.0","element-write-attribute!");assert_string(ar[1]);return $(ar[0]).attr(ar[1],ar[2])});alias_libfunc("element-write-attribute","element-write-attribute!");define_libfunc("element-height",1,1,function(ar){return $(ar[0]).height()});define_libfunc("element-width",1,1,function(ar){return $(ar[0]).width()});define_libfunc("element-class-names",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-has-class-name?",2,2,function(ar){assert_string(ar[1]);return $(ar[0]).hasClass(ar[1])});define_libfunc("element-add-class-name",2,2,function(ar){BiwaScheme.deprecate("element-add-class-name","1.0","element-add-class-name!");assert_string(ar[1]);return $(ar[0]).addClass(ar[1])});alias_libfunc("element-add-class-name","element-add-class-name!");define_libfunc("element-remove-class-name",2,2,function(ar){BiwaScheme.deprecate("element-remove-class-name","1.0","element-remove-class-name!");assert_string(ar[1]);return $(ar[0]).removeClass(ar[1])});alias_libfunc("element-remove-class-name","element-remove-class-name!");define_libfunc("element-toggle-class-name",2,2,function(ar){BiwaScheme.deprecate("element-toggle-class-name","1.0","element-toggle-class-name!");assert_string(ar[1]);return $(ar[0]).toggleClass(ar[1])});alias_libfunc("element-toggle-class-name","element-toggle-class-name!");define_libfunc("element-clean-whitespace!",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-empty?",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-descendant-of!",2,2,function(ar){throw new Bug("not yet implemented")});define_libfunc("scroll-to-element!",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-style",2,2,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-opacity",2,2,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-style-set!",2,2,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-opacity-set!",2,2,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-dimensions",1,1,function(ar){return new Values($(ar[0]).width(),$(ar[0]).height())});define_libfunc("element-make-positioned!",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-undo-positioned!",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-make-clipping!",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-undo-clipping!",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-cumulative-offset",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-positioned-offset",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-absolutize!",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-relativize!",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-cumulative-scroll-offset",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-offset-parent",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-viewport-offset",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-clone-position!",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-absolutize!",1,1,function(ar){throw new Bug("not yet implemented")});define_libfunc("element-focus!",1,1,function(ar){return $(ar[0]).focus()});BiwaScheme.create_elements_by_string=function(spec){spec=spec.to_array();var name=spec.shift();if(name instanceof Symbol)name=name.name;var m=name.match(/(.*)\.(.*)/);if(m){name=m[1];spec.unshift(Sym("class"),m[2])}m=name.match(/(.*)\#(.*)/);if(m){name=m[1];spec.unshift(Sym("id"),m[2])}var children=[];var s=["<"+name];for(var i=0;i<spec.length;i++){if(spec[i]instanceof Symbol){s.push(" "+spec[i].name+'="'+spec[i+1]+'"');i++}else{if(spec[i]instanceof Pair)children.push(create_elements_by_string(spec[i]));else children.push(spec[i])}}s.push(">");s.push(children.join(""));s.push("</"+name+">");return s.join("")};BiwaScheme.tree_all=function(tree,pred){if(tree===nil)return true;else if(pred(tree.car)===false)return false;else return BiwaScheme.tree_all(tree.cdr,pred)};define_libfunc("element-new",1,1,function(ar){var string_or_symbol=function(item){return _.isString(item)||item instanceof Symbol||item instanceof Pair};if(BiwaScheme.tree_all(ar[0],string_or_symbol)){return $(create_elements_by_string(ar[0]))[0]}else{return nil}});BiwaScheme.element_content=function(selector){if($(selector).attr("value")){return $(selector).val()}else{return _.escape($(selector).html())}};define_libfunc("element-content",1,1,function(ar){return BiwaScheme.element_content(ar[0])});define_libfunc("load",1,1,function(ar,intp){var path=ar[0];assert_string(path);var intp2=new Interpreter(intp);return new BiwaScheme.Pause(function(pause){$.ajax(path,{success:function(data){intp2.evaluate(data,function(){return pause.resume(BiwaScheme.undef)})},error:function(){throw new Error("load: network error: failed to load"+path)}})})});_require=function(src,check,proc){var script=$("<script/>",{src:src});$("body").append(script);var checker=new Function("return !!("+check+")");if(checker())proc();else setTimeout(function(){checker()?proc():setTimeout(arguments.callee,10)},10)};define_libfunc("js-load",2,2,function(ar){var path=ar[0];var check=ar[1];assert_string(path);assert_string(check);return new BiwaScheme.Pause(function(pause){_require(path,"window."+check,function(){pause.resume(BiwaScheme.undef)})})});BiwaScheme.getelem=function(ar){if(ar.length>1&&ar[1]===false){ar[1]=[]}var x=$.apply(this,ar);if(x.length>0){return x}else{return false}};define_libfunc("$",1,2,BiwaScheme.getelem);define_libfunc("getelem",1,2,BiwaScheme.getelem);define_libfunc("dom-element",1,1,function(ar){return $(ar[0])[0]});define_libfunc("set-style!",3,3,function(ar){assert_string(ar[1]);$(ar[0]).css(ar[1],ar[2]);return BiwaScheme.undef});define_libfunc("get-style",2,2,function(ar){assert_string(ar[1]);return $(ar[0]).css(ar[1])});define_libfunc("set-content!",2,2,function(ar){assert_string(ar[1]);var str=ar[1].replace(/\n/g,"<br>").replace(/\t/g,"&nbsp;&nbsp;&nbsp;");$(ar[0]).html(str);return BiwaScheme.undef});define_libfunc("get-content",1,1,function(ar){return BiwaScheme.element_content(ar[0])});define_libfunc("set-handler!",3,3,function(ar,intp){throw new Error("set-handler! is obsolete, please use add-handler! instead")});define_libfunc("add-handler!",3,3,function(ar,intp){var selector=ar[0],evtype=ar[1],proc=ar[2];var intp2=new Interpreter(intp);var handler=function(event){return _.clone(intp2).invoke_closure(proc,[event])};$(selector).bind(evtype,handler);return handler});define_libfunc("remove-handler!",3,3,function(ar,intp){var selector=ar[0],evtype=ar[1],handler=ar[2];$(selector).unbind(evtype,handler);return BiwaScheme.undef});define_libfunc("wait-for",2,2,function(ar){var selector=ar[0],evtype=ar[1];var elem=$(selector);elem.biwascheme_wait_for=elem.biwascheme_wait_for||{};var prev_handler=elem.biwascheme_wait_for[evtype];if(prev_handler){elem.unbind(evtype,prev_handler)}return new BiwaScheme.Pause(function(pause){var handler=function(event){elem.biwascheme_wait_for[evtype]=undefined;elem.unbind(evtype,handler);return pause.resume(BiwaScheme.undef)};elem.biwascheme_wait_for[evtype]=handler;elem.bind(evtype,handler)})});define_libfunc("domelem",1,null,function(ar){throw new Error("obsolete")});define_libfunc("dom-remove-children!",1,1,function(ar){puts("warning: dom-remove-children! is obsolete. use element-empty! instead");$(ar[0]).empty();return BiwaScheme.undef});define_libfunc("dom-create-element",1,1,function(ar){throw new Error("obsolete")});define_libfunc("element-append-child!",2,2,function(ar){return $(ar[0]).append(ar[1])});define_libfunc("dom-remove-child!",2,2,function(ar){throw new Error("obsolete")});define_libfunc("http-request",1,1,function(ar){var path=ar[0];assert_string(path);return new BiwaScheme.Pause(function(pause){$.get(path,function(data){pause.resume(data)},"text")})});define_libfunc("http-post",2,2,function(ar){var path=ar[0];assert_string(path);var alist=ar[1];assert_list(alist);var h=alist_to_js_obj(alist);return new BiwaScheme.Pause(function(pause){$.post(path,h,function(data){pause.resume(data)},"text")})});BiwaScheme.jsonp_receiver=[];define_libfunc("receive-jsonp",1,1,function(ar){var url=ar[0];assert_string(url);var receives=BiwaScheme.jsonp_receiver;for(var i=0;i<receives.length;i++)if(receives[i]===null)break;var receiver_id=i;url+="?callback=BiwaScheme.jsonp_receiver["+receiver_id+"]";return new BiwaScheme.Pause(function(pause){receives[receiver_id]=function(data){pause.resume(data);receives[receiver_id]=null};var script=$("<script/>",{src:url});$("body").append(script)})});define_libfunc("alert",1,1,function(ar){alert(ar[0]);return BiwaScheme.undef});define_libfunc("confirm",1,1,function(ar){return confirm(ar[0])})}with(BiwaScheme){BiwaScheme.Dumper=BiwaScheme.Class.create({initialize:function(dumparea){this.dumparea=dumparea||$("#dumparea")[0]||null;this.reset()},reset:function(){if(this.dumparea){$(this.dumparea).empty()}this.n_folds=0;this.closures=[];this.n_dumps=0;this.cur=-1;this.is_folded=true},is_opc:function(obj){return obj instanceof Array&&typeof obj[0]=="string"},dump_pad:"&nbsp;&nbsp;&nbsp;",dump_opc:function(obj,level,nested){var s="";var pad1="",pad2="";var level=level||0;var nested=nested||false;_.times(level,_.bind(function(){pad1+=this.dump_pad},this));_.times(level+1,_.bind(function(){pad2+=this.dump_pad},this));s+=pad1+'[<span class="dump_opecode">'+obj[0]+"</span>";var i=1;while(!(obj[i]instanceof Array)&&i<obj.length){if(obj[0]=="constant")s+="&nbsp;<span class='dump_constant'>"+this.dump_obj(obj[i])+"</span>";else s+="&nbsp;"+this.dump_obj(obj[i]);i++}if(i<obj.length)s+="<br>\n";for(;i<obj.length;i++){if(this.is_opc(obj[i])){s+=this.dump_opc(obj[i],i==obj.length-1?level:level+1,true)}else{s+=i==obj.length-1?pad1:pad2;s+=this.dump_obj(obj[i])}if(i!=obj.length-1)s+="<br>\n"}s+="]";return nested?s:this.add_fold(s)},fold_limit:20,add_fold:function(s){var lines=s.split(/<br>/gim);if(lines.length>this.fold_limit){var fold_btn=" <span style='text-decoration:underline; color:blue; cursor:pointer;'"+"onclick='BiwaScheme.Dumper.toggle_fold("+this.n_folds+")'>more</span>";var fold_start="<div style='display:none' class='fold"+this.n_folds+"'>";var fold_end="</div>";this.n_folds++;return[lines.slice(0,this.fold_limit).join("<br>"),fold_btn,fold_start,lines.slice(this.fold_limit).join("<br>"),fold_end].join("")}else{return s}},stack_max_len:80,dump_stack:function(stk,size){if(stk===null||stk===undefined)return BiwaScheme.inspect(stk);var s="<table>";if(stk.length==0){s+="<tr><td class='dump_dead'>(stack is empty)</td></tr>"}else if(size<stk.length){var l=stk.length-1;s+="<tr><td class='dump_dead'>["+l+"]</td>"+"<td class='dump_dead'>"+_.str.truncate(this.dump_obj(stk[l]),this.stack_max_len)+"</td></tr>"}for(var i=size-1;i>=0;i--){s+="<tr><td class='dump_stknum'>["+i+"]</td>"+"<td>"+_.str.truncate(this.dump_obj(stk[i]),this.stack_max_len)+"</td></tr>"}return s+"</table>"},dump_object:function(obj){var a=[];for(var k in obj){a.push(k.toString())}return"#<Object{"+a.join(",")+"}>"},dump_closure:function(cls){if(cls.length==0)return"[]";var cls_num=null;for(var i=0;i<this.closures.length;i++){if(this.closures[i]==cls)cls_num=i}if(cls_num==null){cls_num=this.closures.length;this.closures.push(cls)}var c=_.clone(cls);var body=c.shift();return["c",cls_num," <span class='dump_closure'>free vars :</span> ",this.dump_obj(c)," <span class='dump_closure'>body :</span> ",_.str.truncate(this.dump_obj(body),100)].join("")},dump_obj:function(obj){if(obj&&typeof obj.to_html=="function")return obj.to_html();else{var s=write_ss(obj,true);if(s=="[object Object]")s=this.dump_object(obj);return _.escape(s)}},dump:function(obj){var s="";if(obj instanceof Object){s+="<table>";s+="<tr><td colspan='4'>"+"<a href='#' class='header'>"+"#"+this.n_dumps+"</a></td></tr>";_.each(_.keys(obj),_.bind(function(key){var value=obj[key];if(key!="x"&&key!="stack"){value=key=="c"?this.dump_closure(value):this.dump_obj(value);s+="<tr><td>"+key+": </td>"+"<td colspan='3'>"+value+"</td></tr>"}},this));s+="<tr><td>x:</td><td>"+(this.is_opc(obj["x"])?this.dump_opc(obj["x"]):this.dump_obj(obj["x"]))+"</td>";s+="<td style='border-left: 1px solid black'>stack:</td><td>"+this.dump_stack(obj["stack"],obj["s"])+"</td></tr>";s+="</table>"}else{s=_.escape(BiwaScheme.inspect(obj))+"<br>\n"}var dumpitem=$("<div/>",{"class":"dump"+this.n_dumps});dumpitem.html(s);$(this.dumparea).append(dumpitem);_.bind(function(n){$(".header",this.dump_el(this.n_dumps)).click(_.bind(function(){this.dump_move_to(n);this.dump_fold()},this))},this)(this.n_dumps);dumpitem.hide();this.n_dumps++},dump_el:function(n){return $(".dump"+n,this.dumparea)},dump_move_to:function(n){if(0<=n&&n<=this.n_dumps){this.dump_el(this.cur).hide();this.cur=n;this.dump_el(this.cur).show()}},dump_move:function(dir){if(0<=this.cur&&this.cur<this.n_dumps)this.dump_el(this.cur).hide();if(0<=this.cur+dir&&this.cur+dir<this.n_dumps)this.cur+=dir;this.dump_el(this.cur).show()},dump_fold:function(){for(var i=0;i<this.n_dumps;i++)if(i!=this.cur)this.dump_el(i).hide();this.is_folded=true},dump_unfold:function(){for(var i=0;i<this.n_dumps;i++)this.dump_el(i).show();this.is_folded=false},dump_toggle_fold:function(){if(this.is_folded)this.dump_unfold();else this.dump_fold()}})}BiwaScheme.Dumper.toggle_fold=function(n){$(".fold"+n,this.dumparea).toggle()};Console={};Console.puts=function(str,no_newline){var console;var text;console=$("#bs-console");if(console[0]){text=_.escape(str+(no_newline?"":"\n"));var span=$("<span>");span.html(text.replace(/\n/g,"<br>").replace(/ /g,"&nbsp;"));console.append(span)}};Console.p=function(){Console.puts("p> "+_.map(_.toArray(arguments),BiwaScheme.inspect).join(" "))};(function(){var dumper=null;if($("#biwascheme-debugger")[0]){dumper=new BiwaScheme.Dumper($("#biwascheme-debugger")[0])}var onError=function(e,state){puts(e.message);if(dumper){dumper.dump(state);dumper.dump_move(1)}else if(typeof console!=="undefined"&&console.error){console.error(e.message)}else{throw e}};var script=$("script[src$='biwascheme.js']").html()||$("script[src$='biwascheme-min.js']").html();if(script){var intp=new BiwaScheme.Interpreter(onError);try{intp.evaluate(script,function(){})}catch(e){onError(e)}}})();